local addon, rhud = ...

rhud.windowdragActive = false

function rhud.dragframe(window, handler, index)
	window:EventAttach(Event.UI.Input.Mouse.Left.Down, function() 
		rhud.windowdragActive = true
		local mouseStatus = Inspect.Mouse()
		win_x = window:GetLeft()
		win_y = window:GetTop()
		rhud.clickOffset["x"] = mouseStatus.x - win_x
		rhud.clickOffset["y"] = mouseStatus.y - win_y
	end, "DragLeftDown" )
	window:EventAttach(Event.UI.Input.Mouse.Left.Up, function()	rhud.windowdragActive = false end, "DragLeftUp")
	window:EventAttach(Event.UI.Input.Mouse.Left.Upoutside, function() rhud.windowdragActive = false end, "DragLeftUpOutside")
	window:EventAttach(Event.UI.Input.Mouse.Cursor.Move, function(frame, hEvent,x,y)
		if rhud.windowdragActive == true then
			new_x = x - rhud.clickOffset["x"]
			new_y = y - rhud.clickOffset["y"]	
			if handler then handler(window, new_x, new_y, index) end
		end
	end, "MouseMove")
end

function rhud.windowmove(window, x, y)
	if window == rhud.WindowDrag then
		rhudSData.locmainx = x
		rhudSData.locmainy = y
		window:SetPoint("TOPLEFT", rhud.Context, "TOPLEFT", rhudSData.locmainx, rhudSData.locmainy)
	end
end
