local addon, rhud = ...

rhud.setpath = {}
rhud.setpath = {
{{ -- Left            Set1
	{xProportional = .68,  yProportional = .02},
	{xProportional = 1,  yProportional =  .04, xControlProportional = .9, yControlProportional = 0},
	{xProportional = 1 ,  yProportional = .96, xControlProportional = -0.1, yControlProportional = .5},
	{xProportional = .68,  yProportional = .98, xControlProportional = .9, yControlProportional = .99}, 
	{xProportional = .68 , yProportional = .02, xControlProportional = -0.5, yControlProportional = .5}
	},
	{ -- Top
	{xProportional = .02,  yProportional = .68},
	{xProportional = .04,  yProportional =  1, xControlProportional = 0, yControlProportional = .9},
	{xProportional =  .96,  yProportional = 1, xControlProportional = .5, yControlProportional = -0.1},
	{xProportional = .98,  yProportional = .68, xControlProportional = 1, yControlProportional = .9}, 
	{xProportional =  .02, yProportional = .68, xControlProportional = .5, yControlProportional = -0.5}
	},
	{ -- Right
	{xProportional = .32,  yProportional = .02},
	{xProportional = 0,  yProportional =  .04, xControlProportional = .1, yControlProportional = 0},
	{xProportional = 0 ,  yProportional = .96, xControlProportional = 1.1, yControlProportional = .5},
	{xProportional = .32,  yProportional = .98, xControlProportional = .1, yControlProportional = .99}, 
	{xProportional = .32 , yProportional = .02, xControlProportional = 1.5, yControlProportional = .5}
	},
	{ -- Bottom
	{xProportional = .02,  yProportional = .32},
	{xProportional = .04,  yProportional =  0, xControlProportional = 0, yControlProportional = .1},
	{xProportional =  .96,  yProportional = 0, xControlProportional = .5, yControlProportional = 1.1},
	{xProportional = .98,  yProportional = .32, xControlProportional = 1, yControlProportional = .1}, 
	{xProportional =  .02, yProportional = .32, xControlProportional = .5, yControlProportional = 1.5}
}},
{{ -- Left              Set2
	{xProportional = .68,  yProportional = .02},
	{xProportional = 1,  yProportional =  .04},
	{xProportional = 1 ,  yProportional = .96, xControlProportional = -0.1, yControlProportional = .5},
	{xProportional = .68,  yProportional = .98}, 
	{xProportional = .68 , yProportional = .02, xControlProportional = -0.5, yControlProportional = .5}
	},
	{ -- Top
	{xProportional = .02,  yProportional = .68},
	{xProportional = .04,  yProportional =  1},
	{xProportional =  .96,  yProportional = 1, xControlProportional = .5, yControlProportional = -0.1},
	{xProportional = .98,  yProportional = .68}, 
	{xProportional =  .02, yProportional = .68, xControlProportional = .5, yControlProportional = -0.5}
	},
	{ -- Right
	{xProportional = .32,  yProportional = .02},
	{xProportional = 0,  yProportional =  .04},
	{xProportional = 0 ,  yProportional = .96, xControlProportional = 1.1, yControlProportional = .5},
	{xProportional = .32,  yProportional = .98}, 
	{xProportional = .32 , yProportional = .02, xControlProportional = 1.5, yControlProportional = .5}
	},
	{ -- Bottom
	{xProportional = .02,  yProportional = .32},
	{xProportional = .04,  yProportional =  0},
	{xProportional =  .96,  yProportional = 0, xControlProportional = .5, yControlProportional = 1.1},
	{xProportional = .98,  yProportional = .32}, 
	{xProportional =  .02, yProportional = .32, xControlProportional = .5, yControlProportional = 1.5}
}},
{{ -- Left              Set3
	{xProportional = .96,  yProportional = .02},
	{xProportional = 1,  yProportional =  .04},
	{xProportional = 1 ,  yProportional = .96, xControlProportional = -0.4, yControlProportional = .5},
	{xProportional = .96,  yProportional = .98}, 
	{xProportional = .96 , yProportional = .02, xControlProportional = -0.9, yControlProportional = .5}
	},
	{ -- Top
	{xProportional = .02,  yProportional = .96},
	{xProportional = .04,  yProportional =  1},
	{xProportional =  .96,  yProportional = 1, xControlProportional = .5, yControlProportional = -0.4},
	{xProportional = .98,  yProportional = .96}, 
	{xProportional =  .02, yProportional = .96, xControlProportional = .5, yControlProportional = -0.9}
	},
	{ -- Right
	{xProportional = .04,  yProportional = .02},
	{xProportional = 0,  yProportional =  .04},
	{xProportional = 0 ,  yProportional = .96, xControlProportional = 1.4, yControlProportional = .5},
	{xProportional = .04,  yProportional = .98}, 
	{xProportional = .04 , yProportional = .02, xControlProportional = 1.9, yControlProportional = .5}
	},
	{ -- Bottom
	{xProportional = .02,  yProportional = .04},
	{xProportional = .04,  yProportional =  0},
	{xProportional =  .96,  yProportional = 0, xControlProportional = .5, yControlProportional = 1.4},
	{xProportional = .98,  yProportional = .04}, 
	{xProportional =  .02, yProportional = .04, xControlProportional = .5, yControlProportional = 1.9}
}},
--Set Path 4 Orb Created Below
}
rhud.setpath[4] = {}
rhud.setpath[4][1] = rhud.RegularPolyPath(5, 0, true)
rhud.setpath[4][2] = rhud.HorseshoePath(4, math.pi, 0.9, 0, -2)
rhud.setpath[4][3] = rhud.HorseshoePath(4, math.pi, 0.9, 0, -1)
rhud.setpath[4][4] = rhud.HorseshoePath(4, math.pi, 0.9, 0, 1)
--end of set 4
rhud.matrix = {}
rhud.fill = {}
function rhud.setmatrix() 
	for i = 1, 12 do
		rhud.matrix[i] = {}
		x = (rhudSData.size[rhudSData.skinval][2].w * (rhudDataTable[i].scale.w / 100))
		y = (rhudSData.size[rhudSData.skinval][2].h * (rhudDataTable[i].scale.h / 100))
		offx = (rhudSData.size[rhudSData.skinval][1].w * (rhudDataTable[i].scale.h / 100))
		offy = (rhudSData.size[rhudSData.skinval][1].h * (rhudDataTable[i].scale.w / 100))
		rhud.matrix[i][1] = Utility.Matrix.Create(x / 100, y / 100, 0, 0, 0)
		rhud.matrix[i][2] = Utility.Matrix.Create(x / 100, y / 100, (math.pi / 2), y, 0)
		rhud.matrix[i][3] = Utility.Matrix.Create(x / 100, y / 100, math.pi, x, y)
		rhud.matrix[i][4] = Utility.Matrix.Create(x / 100, y / 100, -(math.pi / 2), 0, x)
	end
end

function rhud.fillarc(range, maxrange, arc)
	if arc > 10 then pos = 1 - (range/maxrange) else pos = range/maxrange end
	if pos > 1 then pos = 1 end
	if rhudSData.size[rhudSData.skinval][3] == 1 then
		rhud.fill = {type = "gradientLinear", transform = rhud.matrix[arc][rhudDataTable[arc].growth], color = {
			{r=rhudDataTable[arc].color.fs[1], g=rhudDataTable[arc].color.fs[2], b=rhudDataTable[arc].color.fs[3], a=rhudDataTable[arc].color.fs[4], 	position = 0},
			{r=rhudDataTable[arc].color.fe[1], g=rhudDataTable[arc].color.fe[2], b=rhudDataTable[arc].color.fe[3], a=rhudDataTable[arc].color.fe[4], 	position = pos},
			{r=rhudSData.backc[1], g=rhudSData.backc[2], b=rhudSData.backc[3], a=rhudSData.backc[4], 	position = pos + .0001},
			{r=rhudSData.backc[1], g=rhudSData.backc[2], b=rhudSData.backc[3], a=rhudSData.backc[4], 	position = 1.0002},
		}}
		rhud.arc[arc]:SetShape(rhud.path[rhudDataTable[arc].pos], rhud.fill, rhud.stroke)
	end
	if rhudSData.size[rhudSData.skinval][3] == 2 then
		if rhudDataTable[arc].pos == 1 then
			rhud.fill = {type = "gradientLinear", transform = rhud.matrix[arc][rhudDataTable[arc].growth], color = {
				{r=rhudDataTable[arc].color.fs[1], g=rhudDataTable[arc].color.fs[2], b=rhudDataTable[arc].color.fs[3], a=rhudDataTable[arc].color.fs[4], 	position = 0},
				{r=rhudDataTable[arc].color.fe[1], g=rhudDataTable[arc].color.fe[2], b=rhudDataTable[arc].color.fe[3], a=rhudDataTable[arc].color.fe[4], 	position = pos},
				{r=rhudSData.backc[1], g=rhudSData.backc[2], b=rhudSData.backc[3], a=rhudSData.backc[4], 	position = pos + .0001},
				{r=rhudSData.backc[1], g=rhudSData.backc[2], b=rhudSData.backc[3], a=rhudSData.backc[4], 	position = 1.0002},
			}}
			rhud.arc[arc]:SetShape(rhud.path[rhudDataTable[arc].pos], rhud.fill, rhud.stroke)
		end
		if rhudDataTable[arc].pos == 2 then
			rhud.fill = {type = "gradientLinear", transform = rhud.matrix[arc][rhudDataTable[arc].growth], color = {
				{r=rhudDataTable[arc].color.fs[1], g=rhudDataTable[arc].color.fs[2], b=rhudDataTable[arc].color.fs[3], a=rhudDataTable[arc].color.fs[4], 	position = 0},
				{r=rhudDataTable[arc].color.fe[1], g=rhudDataTable[arc].color.fe[2], b=rhudDataTable[arc].color.fe[3], a=rhudDataTable[arc].color.fe[4], 	position = 1},
			}}
			rhud.arc[arc]:SetShape(rhud.HorseshoePath(4, 0, 0.9, range/maxrange, -2), rhud.fill, rhud.stroke)
		end
		if rhudDataTable[arc].pos == 3 then
			rhud.fill = {type = "gradientLinear", transform = rhud.matrix[arc][rhudDataTable[arc].growth], color = {
				{r=rhudDataTable[arc].color.fs[1], g=rhudDataTable[arc].color.fs[2], b=rhudDataTable[arc].color.fs[3], a=rhudDataTable[arc].color.fs[4], 	position = 0},
				{r=rhudDataTable[arc].color.fe[1], g=rhudDataTable[arc].color.fe[2], b=rhudDataTable[arc].color.fe[3], a=rhudDataTable[arc].color.fe[4], 	position = 1},
			}}
			if rhudDataTable[arc].side == 1 then side = -1 else side = 1 end 
			rhud.arc[arc]:SetShape(rhud.HorseshoePath(4, math.pi, 0.9, range/maxrange, side), rhud.fill, rhud.stroke)
		end
		if rhudDataTable[arc].pos == 4 then
			rhud.fill = {type = "gradientLinear", transform = rhud.matrix[arc][rhudDataTable[arc].growth], color = {
				{r=rhudDataTable[arc].color.fs[1], g=rhudDataTable[arc].color.fs[2], b=rhudDataTable[arc].color.fs[3], a=rhudDataTable[arc].color.fs[4], 	position = 0},
				{r=rhudDataTable[arc].color.fe[1], g=rhudDataTable[arc].color.fe[2], b=rhudDataTable[arc].color.fe[3], a=rhudDataTable[arc].color.fe[4], 	position = 1},
			}}
			rhud.arc[arc]:SetShape(rhud.HorseshoePath(4, math.pi, 0.9, range/maxrange, -2), rhud.fill, rhud.stroke)
		end
	end
end
