local addon, rhud = ...
 
--rhudSData = {}
--rhudSData = {locmainx = 0, locmainy = 0, aic = 1, aoc = .6, aoct = .75, gap = 0, islocked = true, isincombat = false, skin = "Rounded", skinval = 1, class = "mage",
-- pcol = { {fs= {.5, .5, 0, 1}, fe = {.86, .8, 0, 1}}, {fs= {0, .2, .6, 1}, fe = {0, .4, .8, 1}}, {fs= {0, .2, .6, 1}, fe = {0, .4, .8, 1}}, {fs= {.5, 0, .5, 1}, fe = {.86, 0, .86, 1}} },
-- fcol = { {fs= {.5, .5, 0, 1}, fe = {.86, .8, 0, 1}}, {fs= {0, .2, .6, 1}, fe = {0, .4, .8, 1}}, {fs= {0, .2, .6, 1}, fe = {0, .4, .8, 1}}, {fs= {.5, 0, .5, 1}, fe = {.86, 0, .86, 1}} },
-- tcol = { {fs= {.5, .5, 0, 1}, fe = {.86, .8, 0, 1}}, {fs= {0, .2, .6, 1}, fe = {0, .4, .8, 1}}, {fs= {0, .2, .6, 1}, fe = {0, .4, .8, 1}}, {fs= {.5, 0, .5, 1}, fe = {.86, 0, .86, 1}} },
-- castcol = { {fs = {0, .42, .87, 1}, fe = {0, .75, .75, 1}}, {fs = {0, .42, .87, 1}, fe = {0, .75, .75, 1}}, {fs= {.5, .5, 0, 1}, fe = {.86, .8, 0, 1}} },
-- backc = {0, 0, 0, .2}, border = 1, borderc = {.7, .7, .7, .5},
-- size = { {{w = 60, h = 256}, {w = 256, h = 60}, 1}, {{w = 60, h = 256}, {w = 256, h = 60}, 1}, {{w = 80, h = 256}, {w = 256, h = 80}, 1}, {{w = 100, h = 100}, {w = 100, h = 100}, 2} },
-- misc = {true, true, true, true, true, true, true, true, true, true}}
rhud.addonId = "RiftHud"
rhud.forcereset = false
rhud.Context = UI.CreateContext("Context")
rhud.Context:SetSecureMode("restricted")
rhud.Window = UI.CreateFrame("Frame", "MainWindow", rhud.Context)
rhud.Window:SetSecureMode("restricted")
rhud.WindowDrag = UI.CreateFrame("Texture", "DragButton", rhud.Context)
rhud.arc = {}
rhud.arcback = {}
rhud.arcbackTT = {}
rhud.arctext = {}
rhud.arctextback = {}
rhud.arctextbackTT = {}
rhud.buffimg = {}
rhud.bufftext = {}
rhud.pbuffimg = {}
rhud.pbufftext = {}
rhud.pbuffrowmax = 1
rhud.tbuffrowmax = 1
rhud.combor = {}
rhud.combormask = {}
rhud.combow = {}
rhud.combowanchor = {}
rhud.combowmask = {}
rhud.clickOffset = {x = 0, y = 0}
rhud.resizeOffset = {x = 0, y = 0}
rhud.hptext = {}
rhud.rstext = {}
rhud.CastbarUpdated = false
for i = 1, 12 do
	rhud.arcback[i] = UI.CreateFrame("Frame", "DragBackground", rhud.Window)
	rhud.arcbackTT[i] = UI.CreateFrame("SimpleTooltip","Player Stats", rhud.Context)
	rhud.arc[i] = UI.CreateFrame("Canvas", "DragBackground", rhud.Window)
	rhud.arctext[i] = UI.CreateFrame("Text", "Percents", rhud.arc[i])
	rhud.arctextback[i] = UI.CreateFrame("Text", "DragPercents", rhud.Window)
	rhud.arctextbackTT[i] = UI.CreateFrame("SimpleTooltip","Player Stats", rhud.Context)
end
rhud.buffimg[1] = UI.CreateFrame("Texture", "BuffIcon", rhud.Window)
rhud.bufftext[1] = UI.CreateFrame("Text", "BuffTimer", rhud.Window)
rhud.pbuffimg[1] = UI.CreateFrame("Texture", "pBuffIcon", rhud.Window)
rhud.pbufftext[1] = UI.CreateFrame("Text", "pBuffTimer", rhud.Window)

rhud.combomask = UI.CreateFrame("Mask", "Combo Warrior Mask", rhud.Window)
rhud.combo = UI.CreateFrame("Texture", "Combo Warrior", rhud.combomask)
rhud.hptext[1] = UI.CreateFrame("Text", "Player HP Amount", rhud.Window)
rhud.rstext[1] = UI.CreateFrame("Text", "Player Resource Amount", rhud.Window)
rhud.hptext[2] = UI.CreateFrame("Text", "Target HP Amount", rhud.Window)
rhud.rstext[2] = UI.CreateFrame("Text", "Target Resource Amount", rhud.Window)

rhud.targetnameback = UI.CreateFrame("Frame", "Target Name Text Anchor", rhud.Window)
rhud.targettnameback = UI.CreateFrame("Frame", "TargetTarget Name Text Anchor", rhud.Window)
rhud.targetnametext = UI.CreateFrame("Text", "Target Name Text", rhud.Window)
rhud.targetclasstext = UI.CreateFrame("Text", "Target Class Text", rhud.Window)
rhud.targetpvpicon = UI.CreateFrame("Texture", "Target PvP Icon", rhud.Window)
rhud.targetmarkicon = UI.CreateFrame("Texture", "Target RaidMark Icon", rhud.Window)
rhud.targettargettext = UI.CreateFrame("Text", "TargetTarget Name", rhud.Window)
rhud.PlayerStat = {}
rhud.PlayerStat = {"Health", 0, 0, "Mana", 0, 0, "Absorb", 0, 100}
rhud.WindowTooltip = UI.CreateFrame("SimpleTooltip","Player Stats", rhud.Context)
rhud.glowTable = {}
rhud.glowTable = {blurX = 3, blurY = 3,	colorA = 1,	colorB = 0,	colorG = 0,	colorR = 0,	knockout = false, offsetX = 0, offsetY = 0, replace = false, strength = 5}

rhud.UnitTable = {"player", "player.target", "player.pet", "focus", "player.target.target"}
rhud.unitDB = {}
rhudUnitDB = {}
rhud.Calling = {"warrior", "cleric", "mage", "rogue"}
rhud.CallingColors = {{1, .25, 0, 1}, {0, 1, 0, 1}, {.8, .5, 1, 1}, {1, 1, 0, 1}}
rhud.unitBuffs = {}
rhud.targetBuffs = {}
rhud.unitBuffsID = {player = "id", target = "id", pet  = "id"}
rhud.events = {}
rhud.OptionsUIElements = {}
rhud.OptionsUIElementsTT = {}
rhud.OptionsUIElementsText = {}
rhud.OptionsUIElementsIcons = {}
rhud.OptionsUIElementsIconsTable = {}
rhud.OptionsUIElementsTextTable = {
	{name = "Level Icon", secure = "restricted", layer = 4},
	{name = "Role Icon", secure = "normal", layer = 4},
	{name = "Planar Icon", secure = "normal", layer = 4},
	{name = "Vitality Icon", secure = "normal", layer = 4},
}
rhud.OptionsUIElementsIconsTable = {
	{name = "Level Icon", addon = "RiftHud", texture = "Textures/level.png", secure = "restricted", layer = 3},
	{name = "Role Icon", addon = "RiftHud", texture = "Textures/tank.png", secure = "normal", layer = 3},
	{name = "Planar Icon", addon = "RiftHud", texture = "Textures/planar.png", secure = "normal", layer = 3},
	{name = "Vitality Icon", addon = "RiftHud", texture = "Textures/vitality.png", secure = "normal", layer = 3},
	{name = "PvP Icon", addon = "RiftHud", texture = "Textures/pvp.png", secure = "normal", layer = 1},
	{name = "Ready Icon", addon = "Rift", texture = "raid_icon_ready.png.dds", secure = "normal", layer = 1},
	{name = "Combat Icon", addon = "RiftHud", texture = "Textures/incombat.png", secure = "normal", layer = 1},
	{name = "Tier Icon", addon = "RiftHud", texture = "Textures/blank.png", secure = "normal", layer = 1},
}
for i = 1, 19 do
rhud.OptionsUIElements[i] = UI.CreateFrame("Frame", "UI Element Frame", rhud.Window)
rhud.OptionsUIElementsTT[i] = UI.CreateFrame("SimpleTooltip", "UI Element Frame", rhud.Context)
end
for i = 1, 5 do
rhud.OptionsUIElementsText[i] = UI.CreateFrame("Text", "UI Element Text", rhud.Window)
end
for i = 1, 8 do
rhud.OptionsUIElementsIcons[i] = UI.CreateFrame("Texture", "UI Element Texture", rhud.Window)
end
rhud.RaidMarkerImages = {
	["1"] = "vfx_ui_mob_tag_01.png.dds",
	["2"] = "vfx_ui_mob_tag_02.png.dds",
	["3"] = "vfx_ui_mob_tag_03.png.dds",
	["4"] = "vfx_ui_mob_tag_04.png.dds",
	["5"] = "vfx_ui_mob_tag_05.png.dds",
	["6"] = "vfx_ui_mob_tag_06.png.dds",
	["7"] = "vfx_ui_mob_tag_07.png.dds",
	["8"] = "vfx_ui_mob_tag_08.png.dds",
	["9"] = "vfx_ui_mob_tag_tank.png.dds",
	["10"] = "vfx_ui_mob_tag_heal.png.dds",
	["11"] = "vfx_ui_mob_tag_damage.png.dds",
	["12"] = "vfx_ui_mob_tag_support.png.dds",
	["13"] = "vfx_ui_mob_tag_arrow.png.dds",
	["14"] = "vfx_ui_mob_tag_skull.png.dds",
	["15"] = "vfx_ui_mob_tag_no.png.dds",
	["16"] = "vfx_ui_mob_tag_smile.png.dds",
	["17"] = "vfx_ui_mob_tag_squirrel.png.dds",
}



------Configuration Setup
rhud.WindowOptions = {}
rhud.WindowOptions = UI.CreateFrame("SimpleWindow", "Configuration", rhud.Context)
rhud.WindowOptions:SetVisible(false)
rhud.WindowOptionsTab = {}
rhud.WindowOptionsTab = UI.CreateFrame("SimpleTabView", "OptionsWindowFrame", rhud.WindowOptions)
rhud.WindowOptionsA = UI.CreateFrame("Frame", "OptionsWindowA", rhud.WindowOptionsTab)
rhud.WindowOptionsB = UI.CreateFrame("Frame", "OptionsWindowB", rhud.WindowOptionsTab)
rhud.WindowOptionsC = UI.CreateFrame("Frame", "OptionsWindowC", rhud.WindowOptionsTab)
rhud.WindowOptionsD = UI.CreateFrame("Frame", "OptionsWindowD", rhud.WindowOptionsTab)
rhud.WindowOptionsE = UI.CreateFrame("Frame", "OptionsWindowE", rhud.WindowOptionsTab)
rhud.WindowOptionsTab:AddTab("Display Toggles", rhud.WindowOptionsA)
rhud.WindowOptionsTab:AddTab("Arc Setup", rhud.WindowOptionsB)
rhud.WindowOptionsTab:AddTab("UI Setup", rhud.WindowOptionsC)
rhud.WindowOptionsTab:AddTab("Arc Colors", rhud.WindowOptionsD)
rhud.WindowOptionsTab:AddTab("Profiles", rhud.WindowOptionsE)
rhud.WindowOptionsColorChooser = UI.CreateFrame("Frame", "ColorChooser", rhud.WindowOptions)
rhud.WindowOptionsColorChooserIcon = UI.CreateFrame("Texture", "ColorChooser", rhud.WindowOptionsB)
rhud.WindowOptionsColorChooserIconS = UI.CreateFrame("Texture", "ColorChooser", rhud.WindowOptionsD)
rhud.WindowOptionsColorChooserIconF = UI.CreateFrame("Texture", "ColorChooser", rhud.WindowOptionsD)
rhud.WindowOptionsColorChooserIconB = UI.CreateFrame("Texture", "ColorChooser", rhud.WindowOptionsD)
rhud.WindowOptionsColorChooserIconBorder = UI.CreateFrame("Texture", "ColorChooser", rhud.WindowOptionsD)

------------Tab A
rhud.OptionsTextATabA = UI.CreateFrame("Text", "Welcome Text", rhud.WindowOptionsA)
rhud.OptionsTextBTabA = UI.CreateFrame("Text", "Welcome Text", rhud.WindowOptionsA)
rhud.OptionsTextCTabA = UI.CreateFrame("Text", "Welcome Text", rhud.WindowOptionsA)
rhud.OptionsTextToggle = {"Show only Debuffs cast by You", "Show Tooltips", "Toggle Target RightClick Menu", "Toggle TargetTarget LeftClick /target", "Show Target Arcs Out of Combat"}
rhud.OptionsSlideATabA = UI.CreateFrame("SimpleSlider", "Alpha", rhud.WindowOptionsA)
rhud.OptionsSlideTextATabA = UI.CreateFrame("Text", "Alpha Text", rhud.WindowOptionsA)
rhud.OptionsSlideBTabA = UI.CreateFrame("SimpleSlider", "Alpha", rhud.WindowOptionsA)
rhud.OptionsSlideBBTabA = UI.CreateFrame("SimpleSlider", "Alpha", rhud.WindowOptionsA)
rhud.OptionsSlideTextBTabA = UI.CreateFrame("Text", "Alpha Text", rhud.WindowOptionsA)
rhud.OptionsSlideTextBBTabA = UI.CreateFrame("Text", "Alpha Text", rhud.WindowOptionsA)
rhud.OptionsSlideCTabA = UI.CreateFrame("SimpleSlider", "Skin", rhud.WindowOptionsA)
rhud.OptionsSlideTextCTabA = UI.CreateFrame("Text", "Skint", rhud.WindowOptionsA)
rhud.OptionsSlideDTabA = UI.CreateFrame("SimpleSlider", "Skin", rhud.WindowOptionsA)
rhud.OptionsSlideTextDTabA = UI.CreateFrame("Text", "Skint", rhud.WindowOptionsA)
rhud.OptionsSlideETabA = UI.CreateFrame("SimpleSlider", "Skin", rhud.WindowOptionsA)
rhud.OptionsSlideTextETabA = UI.CreateFrame("Text", "Skint", rhud.WindowOptionsA)
rhud.OptionsSlideFTabA = UI.CreateFrame("SimpleSlider", "Skin", rhud.WindowOptionsA)
rhud.OptionsSlideTextFTabA = UI.CreateFrame("Text", "Skint", rhud.WindowOptionsA)
rhud.OptionsCheckTabA = {}
for i = 1, 5 do
	rhud.OptionsCheckTabA[i] = UI.CreateFrame("SimpleCheckbox", "PlayerSettings" .. i, rhud.WindowOptionsA)
end
------------Tab A End
------------Tab B
rhud.OptionsSeperatorTabB = UI.CreateFrame("Texture", "Seperator", rhud.WindowOptionsB)
rhud.OptionsRadioATabB = {}
rhud.OptionsSetATabB = Library.LibSimpleWidgets.RadioButtonGroup("rhud.OptionsSetATabB")
for i = 1, 12 do
	rhud.OptionsRadioATabB[i] = UI.CreateFrame("SimpleRadioButton", "OptionsRadioBTabA", rhud.WindowOptionsB)
	rhud.OptionsSetATabB:AddRadioButton(rhud.OptionsRadioATabB[i])
end
rhud.OptionsRadioBTabB = {}
rhud.OptionsSetBTabB = Library.LibSimpleWidgets.RadioButtonGroup("rhud.OptionsSetBTabB")
for i = 1, 4 do
	rhud.OptionsRadioBTabB[i] = UI.CreateFrame("SimpleRadioButton", "OptionsRadioBTabB", rhud.WindowOptionsB)
	rhud.OptionsSetBTabB:AddRadioButton(rhud.OptionsRadioBTabB[i])
end
rhud.OptionsCheckATabB = {}
for i = 1, 12 do
	rhud.OptionsCheckATabB[i] = UI.CreateFrame("SimpleCheckbox", "ArcSettings" .. i, rhud.WindowOptionsB)
end
rhud.OptionsArcAdjustSliderW = UI.CreateFrame("SimpleSlider", "ScaleAdjust", rhud.WindowOptionsB)
rhud.OptionsArcAdjustSliderTextW = UI.CreateFrame("Text", "Text", rhud.WindowOptionsB)
rhud.OptionsArcAdjustSliderH = UI.CreateFrame("SimpleSlider", "ScaleAdjust", rhud.WindowOptionsB)
rhud.OptionsArcAdjustSliderTextH = UI.CreateFrame("Text", "Text", rhud.WindowOptionsB)
rhud.OptionsAspectCheckTabB = UI.CreateFrame("SimpleCheckbox", "Aspect", rhud.WindowOptionsB)
rhud.OptionsRadioCTabB = {}
rhud.OptionsSetCTabB = Library.LibSimpleWidgets.RadioButtonGroup("rhud.OptionsSetCTabB")
for i = 1, 12 do
	rhud.OptionsRadioCTabB[i] = UI.CreateFrame("SimpleRadioButton", "OptionsRadioCTabDuttonB", rhud.WindowOptionsB)
	rhud.OptionsSetCTabB:AddRadioButton(rhud.OptionsRadioCTabB[i])
end
rhud.OptionsCheckBTabB = {}
for i = 1, 12 do
	rhud.OptionsCheckBTabB[i] = UI.CreateFrame("SimpleCheckbox", "TextSettings" .. i, rhud.WindowOptionsB)
end
rhud.OptionsArcAdjustSliderFont = UI.CreateFrame("SimpleSlider", "FontAdjust", rhud.WindowOptionsB)
rhud.OptionsArcAdjustSliderTextFont = UI.CreateFrame("Text", "Text", rhud.WindowOptionsB)
------------Tab B End
------------Tab C
rhud.OptionsRadioATabC = {}
rhud.OptionsCheckATabC = {}
rhud.OptionsSetATabC = Library.LibSimpleWidgets.RadioButtonGroup("rhud.OptionsSetATabC")
rhud.OptionsSliderTextATabC = {}
rhud.OptionsSliderTextATabCLabel = {"Set Width", "Set Height", "Set Font"}
rhud.OptionsSliderATabC = UI.CreateFrame("SimpleSlider", "UI Slider", rhud.WindowOptionsC)
rhud.OptionsSliderBTabC = UI.CreateFrame("SimpleSlider", "UI Slider", rhud.WindowOptionsC)
rhud.OptionsSliderCTabC = UI.CreateFrame("SimpleSlider", "UI Slider", rhud.WindowOptionsC)
rhud.OptionsTextTabC = UI.CreateFrame("Text", "Text", rhud.WindowOptionsC)
rhud.OptionsTextBTabC = UI.CreateFrame("Text", "Text", rhud.WindowOptionsC)
for i = 1, 3 do
	rhud.OptionsSliderTextATabC[i] = UI.CreateFrame("Text", "UI SliderText", rhud.WindowOptionsC)
end
for i = 1, 19 do
	rhud.OptionsCheckATabC[i] = UI.CreateFrame("SimpleCheckbox", "OptionsCheckATabC", rhud.WindowOptionsC)
	rhud.OptionsRadioATabC[i] = UI.CreateFrame("SimpleRadioButton", "OptionsRadioATabC", rhud.WindowOptionsC)
	rhud.OptionsSetATabC:AddRadioButton(rhud.OptionsRadioATabC[i])
end
------------Tab C End
------------Tab D
rhud.OptionsFrameATabD = UI.CreateFrame("Frame", "PlayerArcs", rhud.WindowOptionsD)
rhud.OptionsFrameBTabD = UI.CreateFrame("Frame", "TargetArcs", rhud.WindowOptionsD)
rhud.OptionsFrameCTabD = UI.CreateFrame("Frame", "FocusArcs", rhud.WindowOptionsD)

rhud.OptionsSeperatorATabD = UI.CreateFrame("Texture", "Seperator", rhud.WindowOptionsD)
rhud.OptionsSeperatorBTabD = UI.CreateFrame("Texture", "Seperator", rhud.WindowOptionsD)
rhud.OptionsSeperatorCTabD = UI.CreateFrame("Texture", "Seperator", rhud.WindowOptionsD)

rhud.OptionsTabDTextA = UI.CreateFrame("Text", "Descriptions", rhud.WindowOptionsD)
rhud.OptionsTabDTextB = UI.CreateFrame("Text", "Descriptions", rhud.WindowOptionsD)
rhud.OptionsTabDTextC = UI.CreateFrame("Text", "Descriptions", rhud.WindowOptionsD)
rhud.OptionsTabDTextD = UI.CreateFrame("Text", "Descriptions", rhud.WindowOptionsD)
rhud.OptionsTabDTextE = UI.CreateFrame("Text", "Descriptions", rhud.WindowOptionsD)
rhud.OptionsTabDTextF = UI.CreateFrame("Text", "Descriptions", rhud.WindowOptionsD)
rhud.OptionsTabDTextG = UI.CreateFrame("Text", "Descriptions", rhud.WindowOptionsD)

rhud.OptionsColorSliderB = UI.CreateFrame("SimpleSlider", "ColorC", rhud.WindowOptionsD)
rhud.OptionsColorSliderC = UI.CreateFrame("SimpleSlider", "ColorC", rhud.WindowOptionsD)

rhud.OptionsRadioATabD = {}
rhud.OptionsSetATabD = Library.LibSimpleWidgets.RadioButtonGroup("rhud.OptionsRadioATabD")
for i = 1, 3 do
	rhud.OptionsRadioATabD[i] = UI.CreateFrame("SimpleRadioButton", "OptionsRadioATabD", rhud.WindowOptionsD)
	rhud.OptionsSetATabD:AddRadioButton(rhud.OptionsRadioATabD[i])
end
rhud.OptionsRadioAATabD = {}
rhud.OptionsSetAATabD = Library.LibSimpleWidgets.RadioButtonGroup("rhud.OptionsRadioAATabD")
for i = 1, 4 do
	rhud.OptionsRadioAATabD[i] = UI.CreateFrame("SimpleRadioButton", "OptionsRadioAATabD", rhud.WindowOptionsD)
	rhud.OptionsSetAATabD:AddRadioButton(rhud.OptionsRadioAATabD[i])
end

rhud.OptionsRadioBTabD = {}
rhud.OptionsSetBTabD = Library.LibSimpleWidgets.RadioButtonGroup("rhud.OptionsSetBTabD")
rhud.OptionsSetBTabDArc = UI.CreateFrame("Canvas", "Config Texture", rhud.WindowOptionsD)
for i = 1, 9 do
	rhud.OptionsRadioBTabD[i] = UI.CreateFrame("SimpleRadioButton", "OptionsRadioBTabDuttonC", rhud.OptionsFrameATabD)
	rhud.OptionsSetBTabD:AddRadioButton(rhud.OptionsRadioBTabD[i])
end
rhud.OptionsRadioCTabD = {}
rhud.OptionsSetCTabD = Library.LibSimpleWidgets.RadioButtonGroup("rhud.OptionsSetCTabD")
rhud.OptionsSetCTabDArc = UI.CreateFrame("Canvas", "Config Texture", rhud.OptionsFrameBTabD)
for i = 1, 7 do
	rhud.OptionsRadioCTabD[i] = UI.CreateFrame("SimpleRadioButton", "OptionsRadioBTabDuttonC", rhud.OptionsFrameBTabD)
	rhud.OptionsSetCTabD:AddRadioButton(rhud.OptionsRadioCTabD[i])
end
rhud.OptionsRadioDTabD = {}
rhud.OptionsSetD = Library.LibSimpleWidgets.RadioButtonGroup("rhud.OptionsSetD")
rhud.OptionsSetDTabDArc = UI.CreateFrame("Canvas", "Config Texture", rhud.OptionsFrameCTabD)
for i = 1, 6 do
	rhud.OptionsRadioDTabD[i] = UI.CreateFrame("SimpleRadioButton", "OptionsRadioBTabDuttonD", rhud.OptionsFrameCTabD)
	rhud.OptionsSetD:AddRadioButton(rhud.OptionsRadioDTabD[i])
end
------------Tab D End------------
------------Tab E Start----------
rhud.OptionsListTabE = UI.CreateFrame("SimpleList", "User List", rhud.WindowOptionsE)
rhud.OptionsTextATabE = UI.CreateFrame("Text", "TextA", rhud.WindowOptionsE)
rhud.OptionsTextBTabE = UI.CreateFrame("Text", "TextB", rhud.WindowOptionsE)
rhud.OptionsTextCTabE = UI.CreateFrame("Text", "TextC", rhud.WindowOptionsE)
rhud.OptionsTextDTabE = UI.CreateFrame("Text", "TextD", rhud.WindowOptionsE)
rhud.OptionsTextETabE = UI.CreateFrame("Text", "TextE", rhud.WindowOptionsE)
rhud.OptionsSeperatorATabE = UI.CreateFrame("Texture", "Seperator", rhud.WindowOptionsE)
rhud.OptionsSaveButtonATabE = UI.CreateFrame("RiftButton", "SaveProfile", rhud.WindowOptionsE)
rhud.OptionsSaveButtonBTabE = UI.CreateFrame("RiftButton", "ImportProfile", rhud.WindowOptionsE)
------------Tab E End------------
function rhud.RegularPolyPath(points, rotation, lambda) ------Provided by Baanano
	rotation = math.pi / 2 - (rotation or 0)
	if lambda == true then lambda = 2 - math.cos(math.pi / points) end
	local path = { { xProportional = 0.5 + math.cos(rotation) / 2, yProportional = 0.5 + -1 * math.sin(rotation) / 2 } }
	for i = 1, points do
	 	path[#path + 1] = {
		xProportional = 0.5 + math.cos(math.pi * 2 * i / points + rotation) / 2,
		yProportional = 0.5 + -1 * math.sin(math.pi * 2 * i / points + rotation) / 2,
		xControlProportional = lambda and 0.5 + lambda * math.cos(math.pi * (2 * i - 1) / points + rotation) / 2 or nil,
		yControlProportional = lambda and 0.5 + -1 * lambda * math.sin(math.pi * (2 * i - 1) / points + rotation) / 2 or nil,
	 	}
	end
	return path
end

function rhud.HorseshoePath(points, rotation, radius, percent, size) ------Provided by Baanano
	local firstAngle = math.pi / 2 - (rotation or 0)
	local stepAngle = size * math.pi * percent / points -- -2 / 2 to change dirs. -1 / 1 to only go half way.
	local lambda = 2 - math.cos(stepAngle / 2)
	
	local path = { { xProportional = 0.5 + math.cos(firstAngle) / 2, yProportional = 0.5 + -1 * math.sin(firstAngle) / 2 } }
	for i = 1, points do
		path[#path + 1] = {
		xProportional = 0.5 + math.cos(firstAngle + i * stepAngle) / 2,
		yProportional = 0.5 + -1 * math.sin(firstAngle + i * stepAngle) / 2,
		xControlProportional = 0.5 + lambda * math.cos(firstAngle + (i - 0.5) * stepAngle) / 2,
		yControlProportional = 0.5 + -1 * lambda * math.sin(firstAngle + (i - 0.5) * stepAngle) / 2,
		}
	end
	path[#path + 1] = { xProportional = 0.5 + radius * math.cos(firstAngle + points * stepAngle) / 2, yProportional = 0.5 + -1 * radius * math.sin(firstAngle + points * stepAngle) / 2 }
	for i = points - 1, 0, -1  do
		path[#path + 1] = {
		xProportional = 0.5 + radius * math.cos(firstAngle + i * stepAngle) / 2,
		yProportional = 0.5 + -1 * radius * math.sin(firstAngle + i * stepAngle) / 2,
		xControlProportional = 0.5 + lambda * radius * math.cos(firstAngle + (i + 0.5) * stepAngle) / 2,
		yControlProportional = 0.5 + -1 * lambda * radius * math.sin(firstAngle + (i + 0.5) * stepAngle) / 2,
		}
	end
	path[#path + 1] = { xProportional = 0.5 + math.cos(firstAngle) / 2, yProportional = 0.5 + -1 * math.sin(firstAngle) / 2 }
	return path
end

function rhud.dprint(arg) if rhudDebug == true then print("DEBUG: " .. arg) end end
function rhud.cprint(arg, clr)
	if clr == nil then clr = "white" end
	if clr == "red" then color = "#FF0000" end
	if clr == "blue" then color = "#0000FF" end
	if clr == "cyan" then color = "#00FFFF" end
	if clr == "yellow" then color = "#FFFF00" end
	if clr == "orange" then color = "#FFA500" end
	if clr == "green" then color = "#008000" end
	if clr == "white" then color = "#FFFFFF" end
	Command.Console.Display("general", false, "<font color='" .. color .."'>" .. arg .. "</font>", true)
end
