local addon, rhud = ...

function rhud.createOptionsTabA()
--Display Toggles
	rhud.OptionsTextATabA:SetPoint("TOPCENTER", rhud.WindowOptionsA, "TOPCENTER", 0, 30)
	rhud.OptionsTextATabA:SetFontSize(40)
	rhud.OptionsTextATabA:SetFontColor(1, .6, 0, 1)
	rhud.OptionsTextATabA:SetEffectGlow(rhud.glowTable)
	rhud.OptionsTextATabA:SetText("Welcome to RiftHud!")
	rhud.OptionsTextBTabA:SetPoint("TOPCENTER", rhud.WindowOptionsA, "TOPCENTER", 0, 100)
	rhud.OptionsTextBTabA:SetFontSize(20)
	rhud.OptionsTextBTabA:SetEffectGlow(rhud.glowTable)
	rhud.OptionsTextBTabA:SetText("Configure many options in the following Tabs.")
	rhud.OptionsTextCTabA:SetPoint("TOPCENTER", rhud.WindowOptionsA, "TOPCENTER", 200, 5)
	rhud.OptionsTextCTabA:SetFontSize(20)
	rhud.OptionsTextCTabA:SetFontColor(0, .8, 1, 1)
	rhud.OptionsTextCTabA:SetEffectGlow(rhud.glowTable)
	rhud.OptionsTextCTabA:SetText(rhudSData.version)
	for i = 1, 5 do
		rhud.OptionsCheckTabA[i]:SetPoint("TOPLEFT", rhud.WindowOptionsA, "TOPLEFT", 20, 160 + (i * 20))
		rhud.OptionsCheckTabA[i]:SetFontSize(14)
		rhud.OptionsCheckTabA[i]:SetLayer(1)
		rhud.OptionsCheckTabA[i]:SetText(rhud.OptionsTextToggle[i])
	end
	for i = 1, 5 do
		rhud.OptionsCheckTabA[i]:SetChecked(rhudSData.misc[i])
		rhud.OptionsCheckTabA[i].Event.CheckboxChange = function ()
			rhudSData.misc[i] = rhud.OptionsCheckTabA[i]:GetChecked()
			if i == 2 then
				if rhudSData.misc[2] == true then
					rhud.WindowTooltip:InjectEvents(rhud.OptionsUIElementsText[1], function ()
					stattext = "Click to Open Options \n"
					stattext = stattext .. "Middle Click to Move \n"
					stattext = stattext .. rhud.PlayerStat[1] .. ":  " .. rhud.PlayerStat[2] .. " / " .. rhud.PlayerStat[3] .. "\n"
					stattext = stattext .. rhud.PlayerStat[4] .. ":  " .. rhud.PlayerStat[5] .. " / " .. rhud.PlayerStat[6] .. "\n"
					stattext = stattext .. rhud.PlayerStat[7] .. ":  " .. rhud.PlayerStat[8] .. " / " .. rhud.PlayerStat[9] .. "\n"
					return stattext	end)
				else
					rhud.WindowTooltip:RemoveEvents(rhud.OptionsUIElementsText[1], function () stattext = "" return stattext end)
				end
			end
			if i == 3 then 
				if rhudSData.isincombat == false then	rhud.targetnameback:SetVisible(rhudSData.misc[i]) end
			end
			if i == 4 then 
				if rhudSData.isincombat == false then	rhud.targettnameback:SetVisible(rhudSData.misc[i]) end
			end
			if i == 5 then 
				if rhudSData.isincombat == false then rhud.arc[8]:SetVisible(rhudSData.misc[5]) rhud.arc[9]:SetVisible(rhudSData.misc[5]) end
			end
		end
	end
	rhud.OptionsSlideTextATabA:SetPoint("TOPLEFT", rhud.WindowOptionsA, "TOPLEFT", 300, 180)
	rhud.OptionsSlideTextATabA:SetText("Alpha Transparency while in Combat")
	rhud.OptionsSlideTextBTabA:SetPoint("TOPLEFT", rhud.WindowOptionsA, "TOPLEFT", 300, 230)
	rhud.OptionsSlideTextBTabA:SetText("Alpha Transparency out of Combat (No Target)")
	rhud.OptionsSlideTextBBTabA:SetPoint("TOPLEFT", rhud.WindowOptionsA, "TOPLEFT", 300, 280)
	rhud.OptionsSlideTextBBTabA:SetText("Alpha Transparency out of Combat (With Target)")
	rhud.OptionsSlideTextCTabA:SetPoint("TOPLEFT", rhud.WindowOptionsA, "TOPLEFT", 300, 330)
	rhud.OptionsSlideTextCTabA:SetText("Current HUD skin: " .. rhudSData.skin)
	rhud.OptionsSlideTextFTabA:SetPoint("TOPLEFT", rhud.WindowOptionsA, "TOPLEFT", 20, 350)
	rhud.OptionsSlideTextFTabA:SetText("Adjust Gap Between Left and Right Sides")
	rhud.OptionsSlideTextDTabA:SetPoint("TOPLEFT", rhud.WindowOptionsA, "TOPLEFT", 20, 400)
	rhud.OptionsSlideTextDTabA:SetText("Adjust Arc Base Widths")
	rhud.OptionsSlideTextETabA:SetPoint("TOPLEFT", rhud.WindowOptionsA, "TOPLEFT", 300, 400)
	rhud.OptionsSlideTextETabA:SetText("Adjust Arc Base Heights")

	rhud.OptionsSlideCTabA:SetPoint("TOPLEFT", rhud.WindowOptionsA, "TOPLEFT", 300, 350)	--Set
	rhud.OptionsSlideCTabA:SetRange(1, 4)
	rhud.OptionsSlideCTabA:SetPosition(rhudSData.skinval)
	function rhud.OptionsSlideCTabA.Event.SliderChange()
		rhudSData.skinval = rhud.OptionsSlideCTabA:GetPosition()
		if rhudSData.skinval == 1 then rhudSData.skin = "Rounded" end
		if rhudSData.skinval == 2 then rhudSData.skin = "Squared" end
		if rhudSData.skinval == 3 then rhudSData.skin = "Sharp" end
		if rhudSData.skinval == 4 then rhudSData.skin = "Orb" end
		rhud.OptionsSlideTextCTabA:SetText("Current HUD skin: " .. rhudSData.skin)
		rhud.OptionsSlideDTabA:SetPosition(math.ceil(rhudSData.size[rhudSData.skinval][1].w))
		rhud.OptionsSlideETabA:SetPosition(math.ceil(rhudSData.size[rhudSData.skinval][1].h))

		if rhudSData.size[rhudSData.skinval][3] == 1 then rhudDataTable = rhudArcTable rhudIconsDB = rhudIconsArcDB end
		if rhudSData.size[rhudSData.skinval][3] == 2 then rhudDataTable = rhudOrbTable rhudIconsDB = rhudIconsOrbDB end
		rhud.setmatrix()
		rhud.path = rhud.setpath[rhudSData.skinval]
		rhud.createWindow()
		rhud.LoadPlayer()
	end

	rhud.OptionsSlideFTabA:SetPoint("TOPLEFT", rhud.WindowOptionsA, "TOPLEFT", 20, 370)  --Gap Adjust
	rhud.OptionsSlideFTabA:SetRange(0, 300)
	rhud.OptionsSlideFTabA:SetPosition(math.ceil(rhudSData.gap))
	function rhud.OptionsSlideFTabA.Event.SliderChange()
		rhudSData.gap = rhud.OptionsSlideFTabA:GetPosition()
		rhud.setmatrix() 
		rhud.createWindow()
		rhud.LoadPlayer()
	end
	
	rhud.OptionsSlideDTabA:SetPoint("TOPLEFT", rhud.WindowOptionsA, "TOPLEFT", 20, 420)  --Base Width
	rhud.OptionsSlideDTabA:SetRange(1, 500)
	rhud.OptionsSlideDTabA:SetPosition(math.ceil(rhudSData.size[rhudSData.skinval][1].w))
	function rhud.OptionsSlideDTabA.Event.SliderChange()
		rhudSData.size[rhudSData.skinval][1].w = rhud.OptionsSlideDTabA:GetPosition()
		rhudSData.size[rhudSData.skinval][2].h = rhud.OptionsSlideDTabA:GetPosition()
		rhud.setmatrix() 
		rhud.createWindow()
		rhud.LoadPlayer()
	end
	
	rhud.OptionsSlideETabA:SetPoint("TOPLEFT", rhud.WindowOptionsA, "TOPLEFT", 300, 420)	--Base Height
	rhud.OptionsSlideETabA:SetRange(1, 500)
	rhud.OptionsSlideETabA:SetPosition(math.ceil(rhudSData.size[rhudSData.skinval][1].h))
	function rhud.OptionsSlideETabA.Event.SliderChange()
		rhudSData.size[rhudSData.skinval][1].h = rhud.OptionsSlideETabA:GetPosition()
		rhudSData.size[rhudSData.skinval][2].w = rhud.OptionsSlideETabA:GetPosition()
		rhud.setmatrix() 
		rhud.createWindow()
		rhud.LoadPlayer()
	end
	
	rhud.OptionsSlideATabA:SetPoint("TOPLEFT", rhud.WindowOptionsA, "TOPLEFT", 300, 200)	--Alpha in Combat
	rhud.OptionsSlideATabA:SetRange(1, 100)
	rhud.OptionsSlideATabA:SetPosition(math.ceil(rhudSData.aic * 100))
	function rhud.OptionsSlideATabA.Event.SliderChange()
		rhudSData.aic = rhud.OptionsSlideATabA:GetPosition() / 100
		rhud.Window:SetAlpha(rhudSData.aic)
	end
	rhud.OptionsSlideBTabA:SetPoint("TOPLEFT", rhud.WindowOptionsA, "TOPLEFT", 300, 250)	--Alpha out of Combat
	rhud.OptionsSlideBTabA:SetRange(1, 100)
	rhud.OptionsSlideBTabA:SetPosition(math.ceil(rhudSData.aoc * 100))
	function rhud.OptionsSlideBTabA.Event.SliderChange()
		rhudSData.aoc = rhud.OptionsSlideBTabA:GetPosition() / 100
		rhud.Window:SetAlpha(rhudSData.aoc)
	end
	rhud.OptionsSlideBBTabA:SetPoint("TOPLEFT", rhud.WindowOptionsA, "TOPLEFT", 300, 300)	--Alpha out of Combat with Target
	rhud.OptionsSlideBBTabA:SetRange(1, 100)
	rhud.OptionsSlideBBTabA:SetPosition(math.ceil(rhudSData.aoct * 100))
	function rhud.OptionsSlideBBTabA.Event.SliderChange()
		rhudSData.aoct = rhud.OptionsSlideBBTabA:GetPosition() / 100
		rhud.Window:SetAlpha(rhudSData.aoct)
	end
end