local addon, rhud = ...

function rhud.createOptionsTabB()
----------------Arcs
rhud.lastarctypesel = 1
	for i = 1, 6 do
		rhud.OptionsCheckATabB[i]:SetPoint("TOPLEFT", rhud.WindowOptionsB, "TOPLEFT", 25 , 5 + (23 * (i - 1)))
		rhud.OptionsCheckATabB[i]:SetFontSize(14)
		rhud.OptionsCheckATabB[i]:SetText("Enabled")
		rhud.OptionsRadioATabB[i]:SetPoint("TOPLEFT", rhud.WindowOptionsB, "TOPLEFT", 100 , 5 + (23 * (i - 1)))
		rhud.OptionsRadioATabB[i]:SetFontSize(14)
		rhud.OptionsRadioATabB[i]:SetText(rhudDataTable[i][1])
	end
	for i = 7, 12 do
		rhud.OptionsCheckATabB[i]:SetPoint("TOPLEFT", rhud.WindowOptionsB, "TOPLEFT", 300 , 5 + (23 * (i - 7)))
		rhud.OptionsCheckATabB[i]:SetFontSize(14)
		rhud.OptionsCheckATabB[i]:SetText("Enabled")
		rhud.OptionsRadioATabB[i]:SetPoint("TOPLEFT", rhud.WindowOptionsB, "TOPLEFT", 375 , 5 + (23 * (i - 7)))
		rhud.OptionsRadioATabB[i]:SetFontSize(14)
		rhud.OptionsRadioATabB[i]:SetText(rhudDataTable[i][1])
	end
	for i = 1, 4 do
		rhud.OptionsRadioBTabB[i]:SetPoint("TOPLEFT", rhud.WindowOptionsB, "TOPLEFT", 65 + (75 * i), 210)
		local text = select(i, "Left", "Top", "Right", "Bottom")
		rhud.OptionsRadioBTabB[i]:SetText(text)
		rhud.OptionsRadioBTabB[i]:SetEnabled(false)
	end
	rhud.OptionsAspectCheckTabB:SetPoint("TOPLEFT", rhud.WindowOptionsB, "TOPLEFT", 25, 165)
	rhud.OptionsAspectCheckTabB:SetFontSize(14)
	rhud.OptionsAspectCheckTabB:SetText("Lock Aspect")
	rhud.OptionsAspectCheckTabB:SetChecked(true)
	rhud.OptionsArcAdjustSliderW:SetPoint("TOPLEFT", rhud.WindowOptionsB, "TOPLEFT", 200, 150)
	rhud.OptionsArcAdjustSliderW:SetWidth(250)
	rhud.OptionsArcAdjustSliderW:SetRange(1, 250)
	rhud.OptionsArcAdjustSliderTextW:SetPoint("TOPLEFT", rhud.OptionsArcAdjustSliderW, "TOPRIGHT", 20, 0)
	rhud.OptionsArcAdjustSliderTextW:SetText("Adjust Width Scale")
	rhud.OptionsArcAdjustSliderH:SetPoint("TOPLEFT", rhud.WindowOptionsB, "TOPLEFT", 200, 180)
	rhud.OptionsArcAdjustSliderH:SetWidth(250)
	rhud.OptionsArcAdjustSliderH:SetRange(1, 250)
	rhud.OptionsArcAdjustSliderTextH:SetPoint("TOPLEFT", rhud.OptionsArcAdjustSliderH, "TOPRIGHT", 20, 0)
	rhud.OptionsArcAdjustSliderTextH:SetText("Adjust Height Scale")
	rhud.OptionsSeperatorTabB:SetTexture("Rift", "header_divider.png.dds")
	rhud.OptionsSeperatorTabB:SetPoint("TOPCENTER", rhud.WindowOptionsB, "TOPCENTER", 0, 230)
	rhud.OptionsSeperatorTabB:SetWidth(500)
	rhud.OptionsSeperatorTabB:SetHeight(10)
	rhud.WindowOptionsColorChooserIcon:SetTexture("RiftHud", "Textures/colorpic.png")
	rhud.WindowOptionsColorChooserIcon:SetPoint("BOTTOMRIGHT", rhud.WindowOptionsB, "BOTTOMRIGHT", -10, -10)
	rhud.WindowOptionsColorChooserIcon:SetVisible(false)
	rhud.WindowOptionsColorChooserIcon:EventAttach(Event.UI.Input.Mouse.Left.Click, function() rhud.WindowOptionsColorChooser:SetVisible(rhud.WindowOptionsColorChooser:GetVisible() == false) end, "LeftClick")

	rhud.OptionsArcAdjustSliderW:SetEnabled(false)
	rhud.OptionsArcAdjustSliderH:SetEnabled(false)
	function rhud.OptionsSetATabB.Event:RadioButtonChange()
		if rhudSData.size[rhudSData.skinval][3] == 2 then
			if rhud.OptionsSetATabB:GetSelectedIndex() == 1 or
				rhud.OptionsSetATabB:GetSelectedIndex() == 3 or
				rhud.OptionsSetATabB:GetSelectedIndex() == 4 or
				rhud.OptionsSetATabB:GetSelectedIndex() == 7 or
				rhud.OptionsSetATabB:GetSelectedIndex() == 9 then
				rhud.ifisring = true
				rhud.OptionsArcAdjustSliderW:SetEnabled(false)
				rhud.OptionsArcAdjustSliderH:SetEnabled(false)
			else
				rhud.ifisring = false
				rhud.OptionsArcAdjustSliderW:SetEnabled(true)
				rhud.OptionsArcAdjustSliderH:SetEnabled(true)
			end
		else
		rhud.OptionsArcAdjustSliderW:SetEnabled(true)
		rhud.OptionsArcAdjustSliderH:SetEnabled(true)
		rhud.ifisring = false
		end
		rhud.WindowOptionsColorChooserIcon:SetVisible(false)
		rhud.WindowOptionsColorChooser:SetVisible(false)
		rhud.colorselect = 0

		for i = 1, 12 do
			rhud.arctextback[i]:SetBackgroundColor(1, 1, 1, 0)
			rhud.arctextback[i]:SetVisible(false)
		end
		if rhudSData.size[rhudSData.skinval][3] == 1 then
			for i = 1, 4 do
				rhud.OptionsRadioBTabB[i]:SetEnabled(true)
			end
		end
		if rhud.lastarcsel == nil then rhud.lastarcsel = rhud.OptionsSetATabB:GetSelectedIndex() else rhud.lastarcsel = rhud.arcsel end
		rhud.arcsel = rhud.OptionsSetATabB:GetSelectedIndex()
		rhud.OptionsRadioBTabB[rhudDataTable[rhud.arcsel].pos]:SetSelected(true, true)
		rhud.OptionsArcAdjustSliderW:SetPosition(rhudDataTable[rhud.arcsel].scale.w, true)
		rhud.OptionsArcAdjustSliderH:SetPosition(rhudDataTable[rhud.arcsel].scale.h, true)
		rhud.arcback[rhud.lastarcsel]:SetBackgroundColor(1, 1, 1, 0)
		rhud.arcback[rhud.lastarcsel]:SetVisible(false)
		rhud.arcback[rhud.arcsel]:SetBackgroundColor(1, 1, 1, .5)
		rhud.arcback[rhud.arcsel]:SetVisible(true)
		rhud.dragframe(rhud.arcback[rhud.arcsel], rhud.arcmove, rhud.arcsel)
	end
	function rhud.OptionsSetBTabB.Event:RadioButtonChange()
		rhud.arctypesel = rhud.OptionsSetBTabB:GetSelectedIndex()
		if (rhud.arctypesel == 1 or rhud.arctypesel == 3) and rhudDataTable[rhud.arcsel].scaledim == 2 then
			print ("You may want to change the way the bars grow when changing orientation this way! (Default: Bottom to Top)")
			rhudDataTable[rhud.arcsel].scaledim = 1
			rhudDataTable[rhud.arcsel].growth = 4
		end
		if (rhud.arctypesel == 2 or rhud.arctypesel == 4) and rhudDataTable[rhud.arcsel].scaledim == 1 then
			print ("You may want to change the way the bars grow when changing orientation this way! (Default: Left to Right)")
			rhudDataTable[rhud.arcsel].scaledim = 2
			rhudDataTable[rhud.arcsel].growth = 1
		end
		rhudDataTable[rhud.arcsel].pos = rhud.arctypesel
		rhud.createWindow()
		rhud.LoadPlayer()
	end
	for i = 1, 12 do
		rhud.OptionsCheckATabB[i]:SetChecked(rhudDataTable[i].enabled)
		rhud.OptionsCheckATabB[i].Event.CheckboxChange = function ()
			rhudDataTable[i].enabled = rhud.OptionsCheckATabB[i]:GetChecked()
			if rhudDataTable[i].enabled == false then rhud.arc[i]:SetVisible(false) end
			if rhudDataTable[i].enabled == true then rhud.arc[i]:SetVisible(true) end
		end
	end
	function rhud.OptionsArcAdjustSliderW.Event.SliderChange()
	local h = 0
	local w = 0
		if rhud.ifisring == true or rhud.arcsel == nil then return end
		if rhud.OptionsAspectCheckTabB:GetChecked() == true then
			w = rhud.OptionsArcAdjustSliderW:GetPosition()
			rhud.OptionsArcAdjustSliderH:SetPosition(rhud.OptionsArcAdjustSliderW:GetPosition(), true)
			h = rhud.OptionsArcAdjustSliderH:GetPosition()
		else
			w = rhud.OptionsArcAdjustSliderW:GetPosition()
			h = rhud.OptionsArcAdjustSliderH:GetPosition()
		end
		rhud.scaleadjust(w, h)
	end
	function rhud.OptionsArcAdjustSliderH.Event.SliderChange()
	local h = 0
	local w = 0
		if rhud.ifisring == true or rhud.arcsel == nil then return end
		if rhud.OptionsAspectCheckTabB:GetChecked() == true then
			rhud.OptionsArcAdjustSliderW:SetPosition(rhud.OptionsArcAdjustSliderH:GetPosition(), true)
			w = rhud.OptionsArcAdjustSliderW:GetPosition()
			h = rhud.OptionsArcAdjustSliderH:GetPosition()
		else
			w = rhud.OptionsArcAdjustSliderW:GetPosition()
			h = rhud.OptionsArcAdjustSliderH:GetPosition()
		end
		rhud.scaleadjust(w, h)
	end
	function rhud.scaleadjust(width, height)
		if rhudSData.size[rhudSData.skinval][3] == 1 then
		rhudDataTable[rhud.arcsel].scale = {w = width, h = height}
		rhud.arcback[rhud.arcsel]:SetWidth(rhudSData.size[rhudSData.skinval][rhudDataTable[rhud.arcsel].scaledim].w * rhudDataTable[rhud.arcsel].scale.w / 100)
		rhud.arcback[rhud.arcsel]:SetHeight(rhudSData.size[rhudSData.skinval][rhudDataTable[rhud.arcsel].scaledim].h * rhudDataTable[rhud.arcsel].scale.h / 100)
		rhud.setmatrix() 
		rhud.fillarc(100, 100, rhud.arcsel)
		end
		if rhudSData.size[rhudSData.skinval][3] == 2 then
			if rhud.arcsel == 2 then
				rhudDataTable[1].scale = {w = width + (40 * width/100), h = height + (40 * height/100)}
				rhudDataTable[2].scale = {w = width, h = height}
				rhudDataTable[3].scale = {w = width + (20 * width/100), h = height + (20 * height/100)}
				rhudDataTable[4].scale = {w = width + (40 * width/100), h = height + (40 * height/100)}
				rhudDataTable[11].scale = {w = width + (60 * width/100), h = height + (60 * height/100)}
				for i = 1, 4 do
					rhud.arcback[i]:SetWidth(rhudSData.size[rhudSData.skinval][rhudDataTable[i].scaledim].w * rhudDataTable[i].scale.w  / 100)
					rhud.arcback[i]:SetHeight(rhudSData.size[rhudSData.skinval][rhudDataTable[i].scaledim].h * rhudDataTable[i].scale.h  / 100)
				end
				rhud.arcback[11]:SetWidth(rhudSData.size[rhudSData.skinval][rhudDataTable[11].scaledim].w * rhudDataTable[11].scale.w  / 100)
				rhud.arcback[11]:SetHeight(rhudSData.size[rhudSData.skinval][rhudDataTable[11].scaledim].h * rhudDataTable[11].scale.h  / 100)
				rhud.setmatrix() 
				for i = 1, 4 do
					rhud.fillarc(100, 100, i)
				end
				rhud.fillarc(100, 100, 11)
			end
			if rhud.arcsel == 5 then
				rhudDataTable[5].scale = {w = width, h = height}
				rhud.arcback[5]:SetWidth(rhudSData.size[rhudSData.skinval][rhudDataTable[5].scaledim].w * rhudDataTable[5].scale.w  / 100)
				rhud.arcback[5]:SetHeight(rhudSData.size[rhudSData.skinval][rhudDataTable[5].scaledim].h * rhudDataTable[5].scale.h  / 100)
				rhud.setmatrix() 
				rhud.fillarc(100, 100, 5)
			end
			if rhud.arcsel == 6 then
				rhudDataTable[6].scale = {w = width, h = height}
				rhudDataTable[7].scale = {w = width + (20 * width/100), h = height + (20 * height/100)}
				rhud.arcback[6]:SetWidth(rhudSData.size[rhudSData.skinval][rhudDataTable[6].scaledim].w * rhudDataTable[6].scale.w  / 100)
				rhud.arcback[6]:SetHeight(rhudSData.size[rhudSData.skinval][rhudDataTable[6].scaledim].h * rhudDataTable[6].scale.h  / 100)
				rhud.arcback[7]:SetWidth(rhudSData.size[rhudSData.skinval][rhudDataTable[7].scaledim].w * rhudDataTable[7].scale.w  / 100)
				rhud.arcback[7]:SetHeight(rhudSData.size[rhudSData.skinval][rhudDataTable[7].scaledim].h * rhudDataTable[7].scale.h  / 100)
				rhud.setmatrix() 
				rhud.fillarc(100, 100, 6)
				rhud.fillarc(100, 100, 7)
			end
			if rhud.arcsel == 8 then
				rhudDataTable[8].scale = {w = width, h = height}
				rhudDataTable[9].scale = {w = width + (20 * width/100), h = height + (20 * height/100)}
				rhudDataTable[12].scale = {w = width + (40 * width/100), h = height + (40 * height/100)}
				rhud.arcback[8]:SetWidth(rhudSData.size[rhudSData.skinval][rhudDataTable[8].scaledim].w * rhudDataTable[8].scale.w  / 100)
				rhud.arcback[8]:SetHeight(rhudSData.size[rhudSData.skinval][rhudDataTable[8].scaledim].h * rhudDataTable[8].scale.h  / 100)
				rhud.arcback[9]:SetWidth(rhudSData.size[rhudSData.skinval][rhudDataTable[9].scaledim].w * rhudDataTable[9].scale.w  / 100)
				rhud.arcback[9]:SetHeight(rhudSData.size[rhudSData.skinval][rhudDataTable[9].scaledim].h * rhudDataTable[9].scale.h  / 100)
				rhud.arcback[12]:SetWidth(rhudSData.size[rhudSData.skinval][rhudDataTable[12].scaledim].w * rhudDataTable[12].scale.w  / 100)
				rhud.arcback[12]:SetHeight(rhudSData.size[rhudSData.skinval][rhudDataTable[12].scaledim].h * rhudDataTable[12].scale.h  / 100)
				rhud.setmatrix() 
				rhud.fillarc(100, 100, 8)
				rhud.fillarc(100, 100, 9)
				rhud.fillarc(100, 100, 12)
			end
			if rhud.arcsel == 10 then
				rhudDataTable[10].scale = {w = width, h = height}
				rhud.arcback[10]:SetWidth(rhudSData.size[rhudSData.skinval][rhudDataTable[10].scaledim].w * rhudDataTable[10].scale.w  / 100)
				rhud.arcback[10]:SetHeight(rhudSData.size[rhudSData.skinval][rhudDataTable[10].scaledim].h * rhudDataTable[10].scale.h  / 100)
				rhud.setmatrix() 
				rhud.fillarc(100, 100, 10)
			end
		end
	end

	function rhud.arcmove(window, x, y, arc)
		new_x = x - ( (rhud.Window:GetLeft() + (rhud.Window:GetWidth() / 2)) - (rhud.arcback[arc]:GetWidth() / 2) )
		new_y = y - ( (rhud.Window:GetTop() + (rhud.Window:GetHeight() / 2)) - (rhud.arcback[arc]:GetHeight() / 2) )
		if new_x < 0 then new_x = new_x + rhudSData.gap
		elseif new_x > 0 then new_x = new_x - rhudSData.gap end
		if new_x < 25 then tx = -1 * rhudSData.gap end
		if new_x > 25 then tx = rhudSData.gap end
		if new_x < 25 and new_x > -25 then tx = 0 end
		rhud.dprint("x: " .. math.ceil(new_x) .. "  y: " .. math.ceil(new_y))
		if rhudSData.size[rhudSData.skinval][3] == 1 then
			rhudDataTable[rhud.arcsel].x = math.ceil(new_x)
			rhudDataTable[rhud.arcsel].y = math.ceil(new_y)
			rhud.arcback[arc]:SetPoint("CENTER", rhud.Window, "CENTER", rhudDataTable[rhud.arcsel].x + tx, rhudDataTable[rhud.arcsel].y)
		end
		if rhudSData.size[rhudSData.skinval][3] == 2 then
			if arc == 2 then
				for i = 1, 4 do
					rhudDataTable[i].x = math.ceil(new_x) rhudDataTable[i].y = math.ceil(new_y) 
					rhud.arcback[i]:SetPoint("CENTER", rhud.Window, "CENTER", rhudDataTable[i].x + tx, rhudDataTable[i].y)
				end
				rhudDataTable[11].x = math.ceil(new_x) rhudDataTable[11].y = math.ceil(new_y) 
				rhud.arcback[11]:SetPoint("CENTER", rhud.Window, "CENTER", rhudDataTable[11].x + tx, rhudDataTable[11].y)
			end
			if arc == 5 then
					rhudDataTable[5].x = math.ceil(new_x) rhudDataTable[5].y = math.ceil(new_y) 
					rhud.arcback[5]:SetPoint("CENTER", rhud.Window, "CENTER", rhudDataTable[5].x + tx, rhudDataTable[5].y)
			end
			if arc == 6 then
					rhudDataTable[6].x = math.ceil(new_x) rhudDataTable[6].y = math.ceil(new_y) 
					rhudDataTable[7].x = math.ceil(new_x) rhudDataTable[7].y = math.ceil(new_y) 
					rhud.arcback[6]:SetPoint("CENTER", rhud.Window, "CENTER", rhudDataTable[6].x + tx, rhudDataTable[6].y)
					rhud.arcback[7]:SetPoint("CENTER", rhud.Window, "CENTER", rhudDataTable[7].x + tx, rhudDataTable[7].y)
			end
			if arc == 8 then
					rhudDataTable[8].x = math.ceil(new_x) rhudDataTable[8].y = math.ceil(new_y) 
					rhudDataTable[9].x = math.ceil(new_x) rhudDataTable[9].y = math.ceil(new_y) 
					rhudDataTable[12].x = math.ceil(new_x) rhudDataTable[12].y = math.ceil(new_y) 
					rhud.arcback[8]:SetPoint("CENTER", rhud.Window, "CENTER", rhudDataTable[8].x + tx, rhudDataTable[8].y)
					rhud.arcback[9]:SetPoint("CENTER", rhud.Window, "CENTER", rhudDataTable[9].x + tx, rhudDataTable[9].y)
					rhud.arcback[12]:SetPoint("CENTER", rhud.Window, "CENTER", rhudDataTable[12].x + tx, rhudDataTable[12].y)
			end
			if arc == 10 then
					rhudDataTable[10].x = math.ceil(new_x) rhudDataTable[10].y = math.ceil(new_y) 
					rhud.arcback[10]:SetPoint("CENTER", rhud.Window, "CENTER", rhudDataTable[10].x + tx, rhudDataTable[10].y)
			end
		end
	end
--------------------------Text-----------------------
	for i = 1, 6 do
		rhud.OptionsCheckBTabB[i]:SetPoint("TOPLEFT", rhud.WindowOptionsB, "TOPLEFT", 25 , 225 + (25 * i))
		rhud.OptionsCheckBTabB[i]:SetFontSize(14)
		rhud.OptionsCheckBTabB[i]:SetText("Enabled")
		rhud.OptionsRadioCTabB[i]:SetPoint("TOPLEFT", rhud.WindowOptionsB, "TOPLEFT", 100 , 225 + (25 * i))
		rhud.OptionsRadioCTabB[i]:SetFontSize(14)
		rhud.OptionsRadioCTabB[i]:SetText(rhudDataTable[i][2])
	end
	for i = 7, 12 do
		rhud.OptionsCheckBTabB[i]:SetPoint("TOPLEFT", rhud.WindowOptionsB, "TOPLEFT", 300 , 225 + (25 * (i - 6)))
		rhud.OptionsCheckBTabB[i]:SetFontSize(14)
		rhud.OptionsCheckBTabB[i]:SetText("Enabled")
		rhud.OptionsRadioCTabB[i]:SetPoint("TOPLEFT", rhud.WindowOptionsB, "TOPLEFT", 375 , 225 + (25 * (i - 6)))
		rhud.OptionsRadioCTabB[i]:SetFontSize(14)
		rhud.OptionsRadioCTabB[i]:SetText(rhudDataTable[i][2])
	end
	rhud.OptionsArcAdjustSliderFont:SetPoint("TOPLEFT", rhud.WindowOptionsB, "TOPLEFT", 100, 420)
	rhud.OptionsArcAdjustSliderTextFont:SetPoint("TOPLEFT", rhud.OptionsArcAdjustSliderFont, "TOPRIGHT", 20, 0)
	rhud.OptionsArcAdjustSliderTextFont:SetText("Adjust Font Size")
	rhud.OptionsArcAdjustSliderFont:SetRange(8, 50)

		rhud.OptionsArcAdjustSliderFont:SetEnabled(false)
	function rhud.OptionsSetCTabB.Event:RadioButtonChange()
		for i = 1, 12 do
			rhud.arcback[i]:SetBackgroundColor(1, 1, 1, 0)
			rhud.arcback[i]:SetVisible(false)
		end
		rhud.WindowOptionsColorChooserIcon:SetVisible(true)
		rhud.colorselect = 1
		rhud.OptionsArcAdjustSliderFont:SetEnabled(true)
		rhud.butsel = rhud.OptionsSetCTabB:GetSelectedIndex()
		if rhud.lastbutsel == nil then rhud.lastbutsel = rhud.OptionsSetCTabB:GetSelectedIndex() else rhud.lastbutsel = rhud.butsel end
		rhud.OptionsArcAdjustSliderFont:SetPosition(rhudDataTable[rhud.butsel].font)
		rhud.arctextback[rhud.lastbutsel]:SetBackgroundColor(1, 1, 1, 0)
		rhud.arctextback[rhud.lastbutsel]:SetVisible(false)
		rhud.arctextback[rhud.butsel]:SetBackgroundColor(1, 1, 1, .5)
		rhud.arctextback[rhud.butsel]:SetVisible(true)
		rhud.dragframe(rhud.arctextback[rhud.butsel], rhud.textmove)
	end
	for i = 1, 12 do
		rhud.OptionsCheckBTabB[i]:SetChecked(rhudDataTable[i].showicon)
		rhud.OptionsCheckBTabB[i].Event.CheckboxChange = function ()
			rhudDataTable[i].showicon = rhud.OptionsCheckBTabB[i]:GetChecked()
			rhud.arctext[i]:SetVisible(rhudDataTable[i].showicon)
		end
	end
	function rhud.OptionsArcAdjustSliderFont.Event.SliderChange()
		if rhud.OptionsArcAdjustSliderFont:GetEnabled() == false then return end
		rhudDataTable[rhud.butsel].font = rhud.OptionsArcAdjustSliderFont:GetPosition()
		rhud.arctext[rhud.butsel]:SetFontSize(rhudDataTable[rhud.butsel].font)
	end
	function rhud.textmove(window, x, y)
		new_x = x - ( (rhud.arcback[rhud.butsel]:GetLeft() + (rhud.arcback[rhud.butsel]:GetWidth() / 2)) - (window:GetWidth() / 2) )
		new_y = y - ( (rhud.arcback[rhud.butsel]:GetTop() + (rhud.arcback[rhud.butsel]:GetHeight() / 2)) - (window:GetHeight() / 2) )
		rhudDataTable[rhud.butsel].tx = math.ceil(new_x)
		rhudDataTable[rhud.butsel].ty = math.ceil(new_y)
		rhud.dprint("tx: " .. math.ceil(new_x) .. "  ty: " .. math.ceil(new_y))
		window:SetPoint("CENTER", rhud.arcback[rhud.butsel], "CENTER", rhudDataTable[rhud.butsel].tx, rhudDataTable[rhud.butsel].ty)
	end
end