local addon, rhud = ...
 

function rhud.createOptionsTabC()
----------------UI Setup
		rhud.OptionsTextTabC:SetPoint("TOPLEFT", rhud.WindowOptionsC, "TOPLEFT", 100, 420)
		rhud.OptionsTextTabC:SetText("Select and then Drag Icons Around Screen for Placement")
		rhud.OptionsTextTabC:SetFontSize(16)
	for i = 1, 9 do
	local opttext
		rhud.OptionsCheckATabC[i]:SetPoint("TOPLEFT", rhud.WindowOptionsC, "TOPLEFT", 20, 22 * i)
		if rhudIconsDB[i].showicon == true then
			opttext = "Show"
			rhud.OptionsCheckATabC[i]:SetChecked(true)
		else
			opttext = "Hide"
		end
		rhud.OptionsCheckATabC[i]:SetFontSize(14)
		rhud.OptionsCheckATabC[i]:SetText(opttext)
		rhud.OptionsRadioATabC[i]:SetPoint("TOPLEFT", rhud.WindowOptionsC, "TOPLEFT", 80, 22 * i)
		rhud.OptionsRadioATabC[i]:SetFontSize(14)
		rhud.OptionsRadioATabC[i]:SetText(rhudIconsDB[i][1])
		rhud.OptionsUIElements[i]:SetVisible(false)
	end
	for i = 10, 19 do
	local opttext
		rhud.OptionsCheckATabC[i]:SetPoint("TOPLEFT", rhud.WindowOptionsC, "TOPLEFT", 270, 22 * (i - 9))
		if rhudIconsDB[i].showicon == true then
			opttext = "Show"
			rhud.OptionsCheckATabC[i]:SetChecked(true)
		else
			opttext = "Hide"
		end
		rhud.OptionsCheckATabC[i]:SetFontSize(14)
		rhud.OptionsCheckATabC[i]:SetText(opttext)
		rhud.OptionsRadioATabC[i]:SetPoint("TOPLEFT", rhud.WindowOptionsC, "TOPLEFT", 330, 22 * (i - 9))
		rhud.OptionsRadioATabC[i]:SetFontSize(14)
		rhud.OptionsRadioATabC[i]:SetText(rhudIconsDB[i][1])
		rhud.OptionsUIElements[i]:SetVisible(false)
	end
		rhud.OptionsSliderATabC:SetPoint("TOPLEFT", rhud.WindowOptionsC, "TOPLEFT", 100, 300)
		rhud.OptionsSliderBTabC:SetPoint("TOPLEFT", rhud.WindowOptionsC, "TOPLEFT", 100, 330)
		rhud.OptionsSliderCTabC:SetPoint("TOPLEFT", rhud.WindowOptionsC, "TOPLEFT", 100, 360)
		rhud.OptionsSliderCTabC:SetVisible(false)
		rhud.OptionsSliderTextATabC[1]:SetPoint("TOPLEFT", rhud.OptionsSliderATabC, "TOPRIGHT", 20, 0)
		rhud.OptionsSliderTextATabC[2]:SetPoint("TOPLEFT", rhud.OptionsSliderBTabC, "TOPRIGHT", 20, 0)
		rhud.OptionsSliderTextATabC[3]:SetPoint("TOPLEFT", rhud.OptionsSliderCTabC, "TOPRIGHT", 20, 0)
	for i = 1, 3 do
		rhud.OptionsSliderTextATabC[i]:SetText(rhud.OptionsSliderTextATabCLabel[i])
		rhud.OptionsSliderTextATabC[i]:SetFontSize(14)
	end
		rhud.OptionsTextBTabC:SetPoint("TOPLEFT", rhud.WindowOptionsC, "TOPLEFT", 80, 330)
		rhud.OptionsTextBTabC:SetText("Width controls amount of buffs per row:")
		rhud.OptionsTextBTabC:SetFontSize(14)
		rhud.OptionsTextBTabC:SetVisible(false)

		rhud.OptionsSliderATabC:SetRange(16, 400)
		rhud.OptionsSliderBTabC:SetRange(16, 400)
		rhud.OptionsSliderCTabC:SetRange(10, 50)
		rhud.butsel = 15		
		rhud.OptionsSliderATabC:SetEnabled(false)
		rhud.OptionsSliderBTabC:SetEnabled(false)
	function rhud.OptionsSetATabC.Event:RadioButtonChange()
		rhud.OptionsSliderATabC:SetEnabled(true)
		rhud.OptionsSliderBTabC:SetEnabled(true)
		if rhud.lastbutsel == nil then rhud.lastbutsel = rhud.OptionsSetATabC:GetSelectedIndex() else rhud.lastbutsel = rhud.butsel end
		rhud.butsel = rhud.OptionsSetATabC:GetSelectedIndex()
		rhud.OptionsSliderATabC:SetPosition(rhudIconsDB[rhud.butsel].width)
		rhud.OptionsSliderBTabC:SetPosition(rhudIconsDB[rhud.butsel].height)
		if rhudIconsDB[rhud.butsel].font == 0 then
			rhud.OptionsSliderCTabC:SetVisible(false)
		else
			rhud.OptionsSliderCTabC:SetVisible(true)
			rhud.OptionsSliderCTabC:SetPosition(rhudIconsDB[rhud.butsel].font)
		end
		if rhud.butsel == 15 or rhud.butsel == 16 then
			rhud.OptionsSliderBTabC:SetVisible(false)
			rhud.OptionsTextBTabC:SetVisible(true)
			if rhud.butsel == 15 then
				rhud.OptionsSliderTextATabC[2]:SetText(tostring(rhudSData.pbuffrow))
			else
				rhud.OptionsSliderTextATabC[2]:SetText(tostring(rhudSData.tbuffrow))
			end
		else
			rhud.OptionsSliderBTabC:SetVisible(true)
			rhud.OptionsTextBTabC:SetVisible(false)
			rhud.OptionsSliderTextATabC[2]:SetText("Set Height")
		end
		rhud.OptionsUIElements[rhud.lastbutsel]:SetBackgroundColor(1, 1, 1, 0)
		rhud.OptionsUIElements[rhud.lastbutsel]:SetVisible(false)
		rhud.OptionsUIElements[rhud.butsel]:SetBackgroundColor(1, 1, 1, .5)
		rhud.OptionsUIElements[rhud.butsel]:SetVisible(true)
		if rhud.OptionsSetATabC:GetSelectedIndex() == 1 then
			rhud.OptionsUIElementsText[1]:SetVisible(false)
		else
			if rhudIconsDB[1].showicon == true then
				rhud.OptionsUIElementsText[1]:SetVisible(true)
			end
		end
		rhud.dragframe(rhud.OptionsUIElements[rhud.butsel], rhud.elementmove)
	end
		
	function rhud.elementmove(window, x, y)
		new_x = x - ( (rhud.Window:GetLeft() + (rhud.Window:GetWidth() / 2)) - (window:GetWidth() / 2) )
		new_y = y - ( (rhud.Window:GetTop() + (rhud.Window:GetHeight() / 2)) - (window:GetHeight() / 2) )
		rhudIconsDB[rhud.butsel].x = math.ceil(new_x)
		rhudIconsDB[rhud.butsel].y = math.ceil(new_y)
		rhud.dprint("element: " .. rhud.butsel .. "  tx: " .. math.ceil(new_x) .. "  ty: " .. math.ceil(new_y))
		window:SetPoint("CENTER", rhud.Window, "CENTER", rhudIconsDB[rhud.butsel].x, rhudIconsDB[rhud.butsel].y)
	end
	function rhud.OptionsSliderATabC.Event.SliderChange()
		if rhud.OptionsSliderATabC:GetEnabled() == false then return end
		local num = rhud.butsel
		rhud.slidesel = rhud.OptionsSliderATabC:GetPosition()
		rhudIconsDB[rhud.butsel].width = rhud.slidesel
		rhud.OptionsUIElements[num]:SetWidth(rhud.slidesel)
		if rhud.butsel == 15 then
			rhudSData.pbuffrow = math.ceil(rhud.OptionsUIElements[num]:GetWidth() / 40)
			rhud.OptionsSliderTextATabC[2]:SetText(tostring(rhudSData.pbuffrow))
			---------------
			local x = 1 local y = 0 local row = rhudSData.pbuffrow
			for j = 2, rhud.pbuffrowmax do
				rhud.pbuffimg[j]:SetPoint("TOPRIGHT", rhud.OptionsUIElements[15], "TOPRIGHT", -x * 40, y * 40) 
				x = x + 1
				if j > (row - 1) then row = row + rhudSData.pbuffrow x = 0 y = y + 1 end
			end
			---------------
		end
		if rhud.butsel == 16 then
			rhudSData.tbuffrow = math.ceil(rhud.OptionsUIElements[num]:GetWidth() / 40)
			rhud.OptionsSliderTextATabC[2]:SetText(tostring(rhudSData.tbuffrow))
			---------------
			local x = 1 local y = 0 local row = rhudSData.tbuffrow
			for j = 2, rhud.tbuffrowmax do
				rhud.buffimg[j]:SetPoint("TOPLEFT", rhud.OptionsUIElements[16], "TOPLEFT", x * 40, y * 40) 
				x = x + 1
				if j > (row - 1) then row = row + rhudSData.tbuffrow x = 0 y = y + 1 end
			end
			---------------
		end
	end
	function rhud.OptionsSliderBTabC.Event.SliderChange()
		if rhud.OptionsSliderBTabC:GetEnabled() == false then return end
		local num = rhud.butsel
		rhud.slidesel = rhud.OptionsSliderBTabC:GetPosition()
		rhudIconsDB[rhud.butsel].height = rhud.slidesel
		rhud.OptionsUIElements[num]:SetHeight(rhud.slidesel)
	end
	function rhud.OptionsSliderCTabC.Event.SliderChange()
		if rhud.OptionsSliderCTabC:GetEnabled() == false then return end
		local num = rhud.butsel
		rhud.slidesel = rhud.OptionsSliderCTabC:GetPosition()
		rhudIconsDB[rhud.butsel].font = rhud.slidesel
		if num < 5 then rhud.OptionsUIElementsText[num]:SetFontSize(rhudIconsDB[num].font) end
		if num == 10 then rhud.hptext[1]:SetFontSize(rhudIconsDB[10].font) rhud.rstext[1]:SetFontSize(rhudIconsDB[10].font) end	
		if num == 11 then rhud.hptext[2]:SetFontSize(rhudIconsDB[11].font) rhud.rstext[2]:SetFontSize(rhudIconsDB[11].font) end	
		if num == 12 then rhud.targetnametext:SetFontSize(rhudIconsDB[12].font) end	
		if num == 13 then rhud.targettargettext:SetFontSize(rhudIconsDB[13].font) end	
		if num == 14 then rhud.OptionsUIElementsText[5]:SetFontSize(rhudIconsDB[14].font) end
		if num == 19 then rhud.targetclasstext:SetFontSize(rhudIconsDB[19].font) end	
	end
	for i = 1, 19 do
		rhud.OptionsCheckATabC[i].Event.CheckboxChange = function()
			if rhud.settingloaded == true and rhudIconsDB[i].showicon == true then rhudIconsDB[i].showicon = false
			elseif rhud.settingloaded == true and rhudIconsDB[i].showicon == false then rhudIconsDB[i].showicon = true end
			if rhudIconsDB[i].showicon == true then opttext = "Show" else opttext = "Hide" end
			rhud.OptionsCheckATabC[i]:SetText(opttext)
			
			if i < 9 then rhud.OptionsUIElementsIcons[i]:SetVisible(rhudIconsDB[i].showicon) end
			if i < 5 then rhud.OptionsUIElementsText[i]:SetVisible(rhudIconsDB[i].showicon) end
			if i == 9 then rhud.combomask:SetVisible(rhudIconsDB[9].showicon) rhud.combo:SetVisible(rhudIconsDB[9].showicon) end
			if i == 10 then rhud.hptext[1]:SetVisible(rhudIconsDB[10].showicon) rhud.rstext[1]:SetVisible(rhudIconsDB[10].showicon) end
			if i == 11 then rhud.hptext[2]:SetVisible(rhudIconsDB[11].showicon) rhud.rstext[2]:SetVisible(rhudIconsDB[11].showicon) end
			if i == 12 then	rhud.targetnametext:SetVisible(rhudIconsDB[12].showicon) end
			if i == 13 then rhud.targettargettext:SetVisible(rhudIconsDB[13].showicon) end
			if i == 14 then rhud.OptionsUIElementsText[5]:SetVisible(rhudIconsDB[14].showicon) end
			if i == 17 then rhud.targetpvpicon:SetVisible(rhudIconsDB[17].showicon) end
			if i == 18 then rhud.targetmarkicon:SetVisible(rhudIconsDB[18].showicon) end
			if i == 19 then	rhud.targetclasstext:SetVisible(rhudIconsDB[19].showicon) end
		end
	end
end