local addon, rhud = ...
 
function rhud.createOptionsTabD()
	for i = 1, 3 do
		rhud.OptionsRadioATabD[i]:SetPoint("TOPLEFT", rhud.WindowOptionsD, "TOPLEFT", 50 + (i * 100), 15)
	end
	rhud.OptionsRadioATabD[1]:SetText("Player Colors")
	rhud.OptionsRadioATabD[2]:SetText("Target Colors")
	rhud.OptionsRadioATabD[3]:SetText("Focus Colors")
	rhud.OptionsRadioATabD[1]:SetSelected(true)
	rhud.colorfield = 1
		rhud.cmatrix = {}
		rhud.cmatrix[1] = Utility.Matrix.Create(125 / 100, 125 / 100, 0, 0, 0)
		rhud.cmatrix[2] = Utility.Matrix.Create(125 / 100, 125 / 100, (math.pi / 2), 125, 0)
		rhud.cmatrix[3] = Utility.Matrix.Create(125 / 100, 125 / 100, math.pi, 125, 125)
		rhud.cmatrix[4] = Utility.Matrix.Create(125 / 100, 125 / 100, -(math.pi / 2), 0, 125)
		
	rhud.configpath = {}
	rhud.configfill = {}
	rhud.configpath = { {xProportional = 0,  yProportional = 0}, {xProportional = 1,  yProportional =  0},	{xProportional = 1,  yProportional = 1}, {xProportional = 0,  yProportional = 1}, {xProportional = 0,  yProportional = 0}}
	rhud.configfill = {type = "gradientLinear", transform = rhud.cmatrix[4], color = {
		{r=rhudDataTable[1].color.fs[1], g=rhudDataTable[1].color.fs[2], b=rhudDataTable[1].color.fs[3], a=rhudDataTable[1].color.fs[4],	position = 0},
		{r=rhudDataTable[1].color.fe[1], g=rhudDataTable[1].color.fe[2], b=rhudDataTable[1].color.fe[3], a=rhudDataTable[1].color.fe[4],	position = 1},
	}}
	rhud.OptionsTabDTextA:SetPoint("TOPLEFT", rhud.WindowOptionsD, "TOPLEFT", 280, 75)
	rhud.OptionsTabDTextA:SetText("Start of Gradient Color")
	rhud.WindowOptionsColorChooserIconS:SetPoint("TOPLEFT", rhud.WindowOptionsD, "TOPLEFT", 450, 70)
	rhud.OptionsTabDTextB:SetPoint("TOPLEFT", rhud.WindowOptionsD, "TOPLEFT", 280, 250)
	rhud.OptionsTabDTextB:SetText("End of Gradient Color")
	rhud.WindowOptionsColorChooserIconF:SetPoint("TOPLEFT", rhud.WindowOptionsD, "TOPLEFT", 450, 250)
	
	rhud.OptionsSeperatorATabD:SetTexture("Rift", "header_divider.png.dds")
	rhud.OptionsSeperatorATabD:SetPoint("TOPCENTER", rhud.WindowOptionsD, "TOPCENTER", 0, 35)
	rhud.OptionsSeperatorATabD:SetWidth(500)
	rhud.OptionsSeperatorATabD:SetHeight(10)

	rhud.OptionsSeperatorBTabD:SetTexture("Rift", "header_divider.png.dds")
	rhud.OptionsSeperatorBTabD:SetPoint("TOPCENTER", rhud.WindowOptionsD, "TOPCENTER", 0, 280)
	rhud.OptionsSeperatorBTabD:SetWidth(500)
	rhud.OptionsSeperatorBTabD:SetHeight(10)

	rhud.OptionsTabDTextC:SetPoint("TOPCENTER", rhud.WindowOptionsD, "TOPCENTER", 0, 295)
	rhud.OptionsTabDTextC:SetText("Growth Position (If using Rings, only color is affected, not the way it grows)")
	for i = 1, 4 do
		rhud.OptionsRadioAATabD[i]:SetPoint("TOPLEFT", rhud.WindowOptionsD, "TOPLEFT", 50 + ((i - 1) * 120), 320)
		local growthtext = select(i, "Left to Right", "Top to Bottom", "Right to Left", "Bottom to Top")
		rhud.OptionsRadioAATabD[i]:SetText(growthtext)
		rhud.OptionsRadioAATabD[i]:SetEnabled(false)
	end
	rhud.OptionsSeperatorCTabD:SetTexture("Rift", "header_divider.png.dds")
	rhud.OptionsSeperatorCTabD:SetPoint("TOPCENTER", rhud.WindowOptionsD, "TOPCENTER", 0, 340)
	rhud.OptionsSeperatorCTabD:SetWidth(500)
	rhud.OptionsSeperatorCTabD:SetHeight(10)

	rhud.OptionsTabDTextD:SetPoint("TOPLEFT", rhud.WindowOptionsD, "TOPLEFT", 80, 355)
	rhud.OptionsTabDTextD:SetText("Background Transparency")
	
	rhud.OptionsColorSliderB:SetPoint("TOPLEFT", rhud.WindowOptionsD, "TOPLEFT", 20, 375)
	rhud.OptionsColorSliderB:SetRange(0, 100)

--	rhud.OptionsColorSliderB:SetPosition((rhudSData.backc[4] * 100))
	rhud.OptionsColorSliderB:SetPosition(math.floor(rhudSData.backc[4] * 100))
	function rhud.OptionsColorSliderB.Event.SliderChange()
		rhudSData.backc[4] = rhud.OptionsColorSliderB:GetPosition() / 100
		rhud.createWindow()
		rhud.LoadPlayer()
	end

	rhud.OptionsTabDTextE:SetPoint("TOPLEFT", rhud.WindowOptionsD, "TOPLEFT", 100, 395)
	rhud.OptionsTabDTextE:SetText("Arc Border Size")
	
	rhud.OptionsColorSliderC:SetPoint("TOPLEFT", rhud.WindowOptionsD, "TOPLEFT", 20, 415)
	rhud.OptionsColorSliderC:SetRange(1, 100)
	rhud.OptionsColorSliderC:SetPosition(math.floor(rhudSData.border * 10))
	function rhud.OptionsColorSliderC.Event.SliderChange()
		rhudSData.border = (rhud.OptionsColorSliderC:GetPosition() / 10)
		rhudSData.borderc[4] = (rhud.OptionsColorSliderC:GetPosition() / 100)
		if rhud.OptionsColorSliderC:GetPosition() < 11 then rhudSData.borderc[4] = (rhud.OptionsColorSliderC:GetPosition() / 10) else
			rhudSData.borderc[4] = 1
		end
		rhud.stroke = { r = rhudSData.borderc[1], g = rhudSData.borderc[2], b = rhudSData.borderc[3], a = rhudSData.borderc[4], thickness = rhudSData.border, cap = "round"}
		rhud.createWindow()
		rhud.LoadPlayer()
	end

	rhud.OptionsTabDTextF:SetPoint("TOPLEFT", rhud.WindowOptionsD, "TOPLEFT", 320, 355)
	rhud.OptionsTabDTextF:SetText("Border Color")
	rhud.WindowOptionsColorChooserIconBorder:SetPoint("TOPLEFT", rhud.WindowOptionsD, "TOPLEFT", 340, 390)
	
	rhud.OptionsTabDTextG:SetPoint("TOPLEFT", rhud.WindowOptionsD, "TOPLEFT", 420, 355)
	rhud.OptionsTabDTextG:SetText("Background Color")
	rhud.WindowOptionsColorChooserIconB:SetPoint("TOPLEFT", rhud.WindowOptionsD, "TOPLEFT", 450, 390)
	
	rhud.OptionsSetBTabDArc:SetPoint("TOPLEFT", rhud.OptionsFrameATabD, "TOPLEFT", 280, 80)
	rhud.OptionsSetBTabDArc:SetHeight(125)
	rhud.OptionsSetBTabDArc:SetWidth(125)
	rhud.OptionsSetBTabDArc:SetShape(rhud.configpath, rhud.configfill, rhud.stroke)
------------------------Player	
	rhud.OptionsFrameATabD:SetPoint("TOPLEFT", rhud.WindowOptionsD, "TOPLEFT", 0, 30)
	rhud.OptionsFrameATabD:SetPoint("BOTTOMRIGHT", rhud.WindowOptionsD, "BOTTOMRIGHT", -300, -150)
	rhud.OptionsSetBTabDArc:SetVisible(false)
	for i = 1, 5 do
		rhud.OptionsRadioBTabD[i]:SetPoint("TOPLEFT", rhud.OptionsFrameATabD, "TOPLEFT", 10, 25 * i)
		rhud.OptionsRadioBTabD[i]:SetText(rhudDataTable[i][1])
	end
	rhud.OptionsRadioBTabD[3]:SetEnabled(false)
	rhud.OptionsRadioBTabD[3]:SetText("Player Resource - Set Below")
	for i = 6, 9 do
		rhud.OptionsRadioBTabD[i]:SetPoint("TOPLEFT", rhud.OptionsFrameATabD, "TOPLEFT", 10, 25 * i)
		rhud.OptionsRadioBTabD[i]:SetText(string.gsub(rhud.Calling[i - 5], "^%l", string.upper))
	end
------------------------Target	
	rhud.OptionsFrameBTabD:SetPoint("TOPLEFT", rhud.WindowOptionsD, "TOPLEFT", 0, 30)
	rhud.OptionsFrameBTabD:SetPoint("BOTTOMRIGHT", rhud.WindowOptionsD, "BOTTOMRIGHT", -300, -150)
	rhud.OptionsFrameBTabD:SetVisible(false)
	for i = 1, 3 do
		rhud.OptionsRadioCTabD[i]:SetPoint("TOPLEFT", rhud.OptionsFrameBTabD, "TOPLEFT", 10, 25 * i)
		rhud.OptionsRadioCTabD[i]:SetText(rhudDataTable[i + 7][1])
	end
	rhud.OptionsRadioCTabD[2]:SetEnabled(false)
	rhud.OptionsRadioCTabD[2]:SetText("Target Resource - Set Below")
	for i = 4, 7 do
		rhud.OptionsRadioCTabD[i]:SetPoint("TOPLEFT", rhud.OptionsFrameBTabD, "TOPLEFT", 10, 25 * i)
		rhud.OptionsRadioCTabD[i]:SetText(string.gsub(rhud.Calling[i - 3], "^%l", string.upper))
	end
-------------------------Focus
	rhud.OptionsFrameCTabD:SetPoint("TOPLEFT", rhud.WindowOptionsD, "TOPLEFT", 0, 30)
	rhud.OptionsFrameCTabD:SetPoint("BOTTOMRIGHT", rhud.WindowOptionsD, "BOTTOMRIGHT", -300, -150)
	rhud.OptionsFrameCTabD:SetVisible(false)
	for i = 1, 2 do
		rhud.OptionsRadioDTabD[i]:SetPoint("TOPLEFT", rhud.OptionsFrameCTabD, "TOPLEFT", 10, 25 * i)
		rhud.OptionsRadioDTabD[i]:SetText(rhudDataTable[i + 6][1])
	end
	rhud.OptionsRadioDTabD[2]:SetEnabled(false)
	rhud.OptionsRadioDTabD[2]:SetText("Focus Resource - Set Below")
	for i = 3, 6 do
		rhud.OptionsRadioDTabD[i]:SetPoint("TOPLEFT", rhud.OptionsFrameCTabD, "TOPLEFT", 10, 25 * i)
		rhud.OptionsRadioDTabD[i]:SetText(string.gsub(rhud.Calling[i - 2], "^%l", string.upper))
	end

----------------Colors-------------------------------------------
	function rhud.OptionsSetATabD.Event:RadioButtonChange()
		local sel = rhud.OptionsSetATabD:GetSelectedIndex()
		rhud.WindowOptionsColorChooserIconS:SetVisible(false)
		rhud.WindowOptionsColorChooserIconF:SetVisible(false)
		if sel == 1 then	rhud.OptionsFrameATabD:SetVisible(true) rhud.OptionsFrameBTabD:SetVisible(false) rhud.OptionsFrameCTabD:SetVisible(false)
			for i = 1, 9 do rhud.OptionsRadioBTabD[i]:SetSelected(false) end
			for i = 1, 4 do rhud.OptionsRadioAATabD[i]:SetEnabled(false) rhud.OptionsRadioAATabD[i]:SetSelected(false) end
			rhudcolorsel, rhud.colorarc = nil, nil
			rhud.OptionsSetBTabDArc:SetVisible(false)
			rhud.colorfield = 1
		end
		if sel == 2 then	rhud.OptionsFrameATabD:SetVisible(false) rhud.OptionsFrameBTabD:SetVisible(true) rhud.OptionsFrameCTabD:SetVisible(false)
			for i = 1, 7 do rhud.OptionsRadioCTabD[i]:SetSelected(false) end
			for i = 1, 4 do rhud.OptionsRadioAATabD[i]:SetEnabled(false) rhud.OptionsRadioAATabD[i]:SetSelected(false) end
			rhudcolorsel, rhud.colorarc = nil, nil
			rhud.OptionsSetCTabDArc:SetVisible(false)
			rhud.colorfield = 2
		end
		if sel == 3 then	rhud.OptionsFrameATabD:SetVisible(false) rhud.OptionsFrameBTabD:SetVisible(false) rhud.OptionsFrameCTabD:SetVisible(true)
			for i = 1, 6 do rhud.OptionsRadioDTabD[i]:SetSelected(false) end
			for i = 1, 4 do rhud.OptionsRadioAATabD[i]:SetEnabled(false) rhud.OptionsRadioAATabD[i]:SetSelected(false) end
			rhudcolorsel, rhud.colorarc = nil, nil
			rhud.OptionsSetDTabDArc:SetVisible(false)
			rhud.colorfield = 3
		end
	end
	function rhud.OptionsSetAATabD.Event:RadioButtonChange()
		local sel = rhud.OptionsSetAATabD:GetSelectedIndex()
		rhudDataTable[rhud.colorarc].growth = sel
		rhud.configfill = {type = "gradientLinear", transform = rhud.cmatrix[rhudDataTable[rhud.colorarc].growth], color = {
			{r=rhudDataTable[rhud.colorarc].color.fs[1], g=rhudDataTable[rhud.colorarc].color.fs[2], b=rhudDataTable[rhud.colorarc].color.fs[3], a=rhudDataTable[rhud.colorarc].color.fs[4],	position = 0},
			{r=rhudDataTable[rhud.colorarc].color.fe[1], g=rhudDataTable[rhud.colorarc].color.fe[2], b=rhudDataTable[rhud.colorarc].color.fe[3], a=rhudDataTable[rhud.colorarc].color.fe[4],	position = 1},
		}}
		rhud.OptionsSetBTabDArc:SetShape(rhud.configpath, rhud.configfill, rhud.stroke)
		rhud.createWindow()
		rhud.LoadPlayer()
	end
	rhud.WindowOptionsColorChooserIconS:SetTexture("RiftHud", "Textures/colorpic.png")
	rhud.WindowOptionsColorChooserIconS:SetVisible(false)
	rhud.WindowOptionsColorChooserIconS:EventAttach(Event.UI.Input.Mouse.Left.Click, function() rhud.colorselect = 2 rhud.WindowOptionsColorChooser:SetVisible(rhud.WindowOptionsColorChooser:GetVisible() == false) end, "LeftClick")
	rhud.WindowOptionsColorChooserIconF:SetTexture("RiftHud", "Textures/colorpic.png")
	rhud.WindowOptionsColorChooserIconF:SetVisible(false)
	rhud.WindowOptionsColorChooserIconF:EventAttach(Event.UI.Input.Mouse.Left.Click, function() rhud.colorselect = 3 rhud.WindowOptionsColorChooser:SetVisible(rhud.WindowOptionsColorChooser:GetVisible() == false) end, "LeftClick")
	rhud.WindowOptionsColorChooserIconB:SetTexture("RiftHud", "Textures/colorpic.png")
	rhud.WindowOptionsColorChooserIconB:SetVisible(true)
	rhud.WindowOptionsColorChooserIconB:EventAttach(Event.UI.Input.Mouse.Left.Click, function() rhud.colorfield = 0 rhud.colorselect = 4 rhud.WindowOptionsColorChooser:SetVisible(rhud.WindowOptionsColorChooser:GetVisible() == false) end, "LeftClick")
	rhud.WindowOptionsColorChooserIconBorder:SetTexture("RiftHud", "Textures/colorpic.png")
	rhud.WindowOptionsColorChooserIconBorder:SetVisible(true)
	rhud.WindowOptionsColorChooserIconBorder:EventAttach(Event.UI.Input.Mouse.Left.Click, function() rhud.colorfield = 0 rhud.colorselect = 5 rhud.WindowOptionsColorChooser:SetVisible(rhud.WindowOptionsColorChooser:GetVisible() == false) end, "LeftClick")

----------------Player
	function rhud.OptionsSetBTabD.Event:RadioButtonChange()
		rhud.WindowOptionsColorChooserIconS:SetVisible(true)
		rhud.WindowOptionsColorChooserIconF:SetVisible(true)
		rhud.colorsel = rhud.OptionsSetBTabD:GetSelectedIndex()
		if rhud.colorsel < 6 then
			rhud.colorarc = rhud.colorsel
		else
			rhud.colorarc = 3
			rhudDataTable[3].color.fs = rhudSData.pcol[(rhud.colorsel - 5)].fs
			rhudDataTable[3].color.fe = rhudSData.pcol[(rhud.colorsel - 5)].fe
		end
		rhud.configfill = {type = "gradientLinear", transform = rhud.cmatrix[rhudDataTable[rhud.colorarc].growth], color = {
			{r=rhudDataTable[rhud.colorarc].color.fs[1], g=rhudDataTable[rhud.colorarc].color.fs[2], b=rhudDataTable[rhud.colorarc].color.fs[3], a=rhudDataTable[rhud.colorarc].color.fs[4],	position = 0},
			{r=rhudDataTable[rhud.colorarc].color.fe[1], g=rhudDataTable[rhud.colorarc].color.fe[2], b=rhudDataTable[rhud.colorarc].color.fe[3], a=rhudDataTable[rhud.colorarc].color.fe[4],	position = 1},
		}}
		rhud.OptionsSetBTabDArc:SetShape(rhud.configpath, rhud.configfill, rhud.stroke)
			
		rhud.OptionsRadioAATabD[rhudDataTable[rhud.colorarc].growth]:SetSelected(true, true)
--		if rhudDataTable[rhud.colorarc].pos == 1 or rhudDataTable[rhud.colorarc].pos == 3 then
--			rhud.OptionsRadioAATabD[1]:SetEnabled(false) rhud.OptionsRadioAATabD[2]:SetEnabled(true) rhud.OptionsRadioAATabD[3]:SetEnabled(false) rhud.OptionsRadioAATabD[4]:SetEnabled(true)
--		else
--			rhud.OptionsRadioAATabD[1]:SetEnabled(true) rhud.OptionsRadioAATabD[2]:SetEnabled(false) rhud.OptionsRadioAATabD[3]:SetEnabled(true) rhud.OptionsRadioAATabD[4]:SetEnabled(false)
--		end
	for i = 1, 4 do rhud.OptionsRadioAATabD[i]:SetEnabled(true) end
	rhud.OptionsSetBTabDArc:SetVisible(true)
	end
----------------Target
	function rhud.OptionsSetCTabD.Event:RadioButtonChange()
		rhud.WindowOptionsColorChooserIconS:SetVisible(true)
		rhud.WindowOptionsColorChooserIconF:SetVisible(true)
		rhud.colorsel = rhud.OptionsSetCTabD:GetSelectedIndex()
		if rhud.colorsel < 4 then
			rhud.colorarc = rhud.colorsel + 7
		else
			rhud.colorarc = 9
			rhudDataTable[9].color.fs = rhudSData.tcol[(rhud.colorsel - 3)].fs
			rhudDataTable[9].color.fe = rhudSData.tcol[(rhud.colorsel - 3)].fe
		end
		rhud.configfill = {type = "gradientLinear", transform = rhud.cmatrix[rhudDataTable[rhud.colorarc].growth], color = {
			{r=rhudDataTable[rhud.colorarc].color.fs[1], g=rhudDataTable[rhud.colorarc].color.fs[2], b=rhudDataTable[rhud.colorarc].color.fs[3], a=rhudDataTable[rhud.colorarc].color.fs[4],	position = 0},
			{r=rhudDataTable[rhud.colorarc].color.fe[1], g=rhudDataTable[rhud.colorarc].color.fe[2], b=rhudDataTable[rhud.colorarc].color.fe[3], a=rhudDataTable[rhud.colorarc].color.fe[4],	position = 1},
		}}
		rhud.OptionsSetBTabDArc:SetShape(rhud.configpath, rhud.configfill, rhud.stroke)
			
		rhud.OptionsRadioAATabD[rhudDataTable[rhud.colorarc].growth]:SetSelected(true, true)
--		if rhudDataTable[rhud.colorarc].pos == 1 or rhudDataTable[rhud.colorarc].pos == 3 then
--			rhud.OptionsRadioAATabD[1]:SetEnabled(false) rhud.OptionsRadioAATabD[2]:SetEnabled(true) rhud.OptionsRadioAATabD[3]:SetEnabled(false) rhud.OptionsRadioAATabD[4]:SetEnabled(true)
--		else
--			rhud.OptionsRadioAATabD[1]:SetEnabled(true) rhud.OptionsRadioAATabD[2]:SetEnabled(false) rhud.OptionsRadioAATabD[3]:SetEnabled(true) rhud.OptionsRadioAATabD[4]:SetEnabled(false)
--		end
		for i = 1, 4 do rhud.OptionsRadioAATabD[i]:SetEnabled(true) end
		rhud.OptionsSetBTabDArc:SetVisible(true)
	end
---------------Focus
	function rhud.OptionsSetD.Event:RadioButtonChange()
		rhud.WindowOptionsColorChooserIconS:SetVisible(true)
		rhud.WindowOptionsColorChooserIconF:SetVisible(true)
		rhud.colorsel = rhud.OptionsSetD:GetSelectedIndex()
		if rhud.colorsel < 3 then
			rhud.colorarc = rhud.colorsel + 5
		else
			rhud.colorarc = 7
			rhudDataTable[7].color.fs = rhudSData.fcol[(rhud.colorsel - 2)].fs
			rhudDataTable[7].color.fe = rhudSData.fcol[(rhud.colorsel - 2)].fe
		end
		rhud.configfill = {type = "gradientLinear", transform = rhud.cmatrix[rhudDataTable[rhud.colorarc].growth], color = {
			{r=rhudDataTable[rhud.colorarc].color.fs[1], g=rhudDataTable[rhud.colorarc].color.fs[2], b=rhudDataTable[rhud.colorarc].color.fs[3], a=rhudDataTable[rhud.colorarc].color.fs[4],	position = 0},
			{r=rhudDataTable[rhud.colorarc].color.fe[1], g=rhudDataTable[rhud.colorarc].color.fe[2], b=rhudDataTable[rhud.colorarc].color.fe[3], a=rhudDataTable[rhud.colorarc].color.fe[4],	position = 1},
		}}
		rhud.OptionsSetBTabDArc:SetShape(rhud.configpath, rhud.configfill, rhud.stroke)
			
		rhud.OptionsRadioAATabD[rhudDataTable[rhud.colorarc].growth]:SetSelected(true, true)
--		if rhudDataTable[rhud.colorarc].pos == 1 or rhudDataTable[rhud.colorarc].pos == 3 then
--			rhud.OptionsRadioAATabD[1]:SetEnabled(false) rhud.OptionsRadioAATabD[2]:SetEnabled(true) rhud.OptionsRadioAATabD[3]:SetEnabled(false) rhud.OptionsRadioAATabD[4]:SetEnabled(true)
--		else
--			rhud.OptionsRadioAATabD[1]:SetEnabled(true) rhud.OptionsRadioAATabD[2]:SetEnabled(false) rhud.OptionsRadioAATabD[3]:SetEnabled(true) rhud.OptionsRadioAATabD[4]:SetEnabled(false)
--		end
		for i = 1, 4 do rhud.OptionsRadioAATabD[i]:SetEnabled(true) end
		rhud.OptionsSetBTabDArc:SetVisible(true)
	end
end