local addon, rhud = ...
 
function rhud.createOptionsTabE()
	rhud.OptionsTextATabE:SetPoint("TOPCENTER", rhud.WindowOptionsE, "TOPCENTER", 0, 20)
	rhud.OptionsTextATabE:SetFontSize(16)
	rhud.OptionsTextATabE:SetHeight(100)
	rhud.OptionsTextATabE:SetWidth(500)
	rhud.OptionsTextATabE:SetWordwrap(true)
	rhud.OptionsTextATabE:SetText("Force Save Profile (This is saved automatically if you logout or /reloadui. You cannot undo changes this session if you force update.)")
	
	rhud.OptionsSaveButtonATabE:SetPoint("TOPCENTER", rhud.WindowOptionsE, "TOPCENTER", 0, 75)
	rhud.OptionsSaveButtonATabE:SetText("Save")
	rhud.OptionsSaveButtonATabE:EventAttach(Event.UI.Input.Mouse.Left.Click, function()
--FIX
	for i = 1, 5 do
		rhudProfilesDB[rhud.unitDB["player"].name][i] = {}
	end
	rhud.profileSave(rhud.unitDB["player"].name)
	end, "SaveButton")
	
	rhud.OptionsSeperatorATabE:SetTexture("Rift", "header_divider.png.dds")
	rhud.OptionsSeperatorATabE:SetPoint("TOPCENTER", rhud.WindowOptionsE, "TOPCENTER", 0, 115)
	rhud.OptionsSeperatorATabE:SetWidth(500)
	rhud.OptionsSeperatorATabE:SetHeight(10)

	rhud.OptionsTextBTabE:SetPoint("TOPCENTER", rhud.WindowOptionsE, "TOPCENTER", 0, 130)
	rhud.OptionsTextBTabE:SetFontSize(16)
	rhud.OptionsTextBTabE:SetText("Import Save Profile")
	
	rhud.OptionsListTabE:SetPoint("TOPLEFT", rhud.WindowOptionsE, "TOPLEFT", 30, 180)
	rhud.OptionsListTabE:SetWidth(220)
	rhud.OptionsListTabE:SetHeight(150)
	rhud.OptionsListTabE:SetBorder(1, 1, 1, 1, 1)
	rhud.OptionsListTabE:SetFontSize(16)
	rhud.buildplayerselectlist()
	rhud.OptionsListTabEsel = ""
	rhud.OptionsListTabE.Event.ItemSelect = function(h, item)
		rhud.OptionsListTabEsel = item
		if rhud.unitDB["player"].name == item then text = "This is You!!!!" else text = item end
		rhud.OptionsTextETabE:SetText("Current selected character: " .. text)
	end

	rhud.OptionsTextCTabE:SetPoint("TOPLEFT", rhud.WindowOptionsE, "TOPCENTER", -20, 175)
	rhud.OptionsTextCTabE:SetFontSize(16)
	rhud.OptionsTextCTabE:SetWordwrap(true)
	rhud.OptionsTextCTabE:SetWidth(300)
	rhud.OptionsTextCTabE:SetHeight(100)
	rhud.OptionsTextCTabE:SetText("Select Character from list that you wish to copy the RiftHud settings from. Select yourself to undo changes this session.")

	rhud.OptionsTextDTabE:SetPoint("TOPLEFT", rhud.WindowOptionsE, "TOPCENTER", -20, 255)
	rhud.OptionsTextDTabE:SetFontSize(16)
	rhud.OptionsTextDTabE:SetWordwrap(true)
	rhud.OptionsTextDTabE:SetWidth(300)
	rhud.OptionsTextDTabE:SetHeight(100)
	rhud.OptionsTextDTabE:SetText("Changes made to your character only affect your character and have no bearing on who you copy settings from.")
-----------	
	rhud.OptionsTextETabE:SetPoint("TOPCENTER", rhud.WindowOptionsE, "TOPCENTER", 0, 350)
	rhud.OptionsTextETabE:SetFontSize(16)
	rhud.OptionsTextETabE:SetWidth(300)
	rhud.OptionsTextETabE:SetText("Current selected character: " .. rhud.OptionsListTabEsel)
	
	rhud.OptionsSaveButtonBTabE:SetPoint("TOPCENTER", rhud.WindowOptionsE, "TOPCENTER", 0, 380)
	rhud.OptionsSaveButtonBTabE:SetText("Import")
	rhud.OptionsSaveButtonBTabE:EventAttach(Event.UI.Input.Mouse.Left.Click, function()
	if rhud.OptionsListTabEsel == "" then print("Please select a character first") return end
	rhud.profileLoad(rhud.OptionsListTabEsel)
	if rhudSData.size[rhudSData.skinval][3] == 1 then rhudDataTable = rhudArcTable rhudIconsDB = rhudIconsArcDB end
	if rhudSData.size[rhudSData.skinval][3] == 2 then rhudDataTable = rhudOrbTable rhudIconsDB = rhudIconsOrbDB end
	rhud.setmatrix()
	rhud.path = rhud.setpath[rhudSData.skinval]
	Command.Console.Display("general", false, "<font color='#FFFF00'>*****RiftHud settings have been imported for you!*****</font>", true)
	rhud.createWindow()
	rhud.LoadPlayer()
	rhud.createOptionsTabA()	
	rhud.createOptionsTabB()	
	rhud.createOptionsTabC()	
	rhud.createOptionsTabD()	
	end, "ImportButton")
end
function rhud.buildplayerselectlist()
	local selectlist = {}
	for k, v in pairs(rhudProfilesDB) do
		table.insert(selectlist, k)
	end
	rhud.OptionsListTabE:SetItems(selectlist)
end

function rhud.profileSave(name)
	rhud.cprint("Populating Profile Data for " .. name, "yellow")
	rhudProfilesDB[name][1] = {}
		rhudProfilesDB[name][1] = rhud.deepcopy(rhudSData)
	rhudProfilesDB[name][2] = {}
		rhudProfilesDB[name][2] = rhud.deepcopy(rhudArcTable)
	rhudProfilesDB[name][3] = {}
		rhudProfilesDB[name][3] = rhud.deepcopy(rhudOrbTable)
	rhudProfilesDB[name][4] = {}
		rhudProfilesDB[name][4] = rhud.deepcopy(rhudIconsArcDB)
	rhudProfilesDB[name][5] = {}
		rhudProfilesDB[name][5] = rhud.deepcopy(rhudIconsOrbDB)
	if rhudSData.version ~= rhud.addondetail.toc.Version then rhudSData.version = rhud.addondetail.toc.Version end
end
function rhud.profileLoad(name)
	rhud.dprint("Importing Profile Data from " .. name)
	rhudSData = rhud.deepcopy(rhudProfilesDB[name][1])
	rhudArcTable = rhud.deepcopy(rhudProfilesDB[name][2])
	rhudOrbTable = rhud.deepcopy(rhudProfilesDB[name][3])
	rhudIconsArcDB = rhud.deepcopy(rhudProfilesDB[name][4])
	rhudIconsOrbDB = rhud.deepcopy(rhudProfilesDB[name][5])
end
function rhud.deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[rhud.deepcopy(orig_key)] = rhud.deepcopy(orig_value)
        end
        setmetatable(copy, rhud.deepcopy(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end
