local addon, rhud = ...
 
function rhud.createOptions()
	if rhudSData.isincombat then return end
	rhud.WindowOptions:SetPoint("TOPCENTER", UIParent, "TOPCENTER")
	rhud.WindowOptions:SetWidth(650)
	rhud.WindowOptions:SetHeight(550)
	
	rhud.WindowOptionsColorChooser:SetPoint("CENTERLEFT", rhud.WindowOptions, "CENTERRIGHT")
	rhud.WindowOptionsColorChooser:SetVisible(false)
	
	function rhud.colorreturn(r, g, b)
		rhud.dprint("r: " .. r .. "  g: " .. g .. "  b: " .. b)
		if rhud.colorselect == 1 then
			rhudDataTable[rhud.butsel].fontc = {r, g, b}
			rhud.arctext[rhud.butsel]:SetFontColor(r, g, b, 1)
			rhud.WindowOptionsColorChooser:SetVisible(false)
		end
		if rhud.colorselect == 2 then
			rhudDataTable[rhud.colorarc].color.fe = {r, g, b, 1}
			if rhud.colorfield == 1 and rhud.colorarc == 3 then rhudSData.pcol[(rhud.colorsel - 5)].fe = {r, g, b, 1} end
			if rhud.colorfield == 2 and rhud.colorarc == 9 then rhudSData.tcol[(rhud.colorsel - 3)].fe = {r, g, b, 1} end
			if rhud.colorfield == 3 and rhud.colorarc == 7 then rhudSData.fcol[(rhud.colorsel - 2)].fe = {r, g, b, 1} end
			rhud.colorapply(rhud.colorarc)
		end
		if rhud.colorselect == 3 then
			rhudDataTable[rhud.colorarc].color.fs = {r, g, b, 1}
			if rhud.colorfield == 1 and rhud.colorarc == 3 then rhudSData.pcol[(rhud.colorsel - 5)].fs = {r, g, b, 1} end
			if rhud.colorfield == 2 and rhud.colorarc == 9 then rhudSData.tcol[(rhud.colorsel - 3)].fs = {r, g, b, 1} end
			if rhud.colorfield == 3 and rhud.colorarc == 7 then rhudSData.fcol[(rhud.colorsel - 2)].fs = {r, g, b, 1} end
		rhud.colorapply(rhud.colorarc)
		end
		if rhud.colorselect == 4 then
		rhudSData.backc[1], rhudSData.backc[2], rhudSData.backc[3] = r, g, b
		rhud.colorapply()
		end
		if rhud.colorselect == 5 then
		rhudSData.borderc[1], rhudSData.borderc[2], rhudSData.borderc[3] = r, g, b
		rhud.stroke = { r = rhudSData.borderc[1], g = rhudSData.borderc[2], b = rhudSData.borderc[3], a = rhudSData.borderc[4], thickness = rhudSData.border, cap = "round"}
		rhud.colorapply()
		end
	end
	Library.ColorChooser.CreateWidget(rhud.WindowOptionsColorChooser, rhud.colorreturn, 8)

	function rhud.colorapply(arc)
		if arc == nil then arc = 1 end
		rhud.configfill = {type = "gradientLinear", transform = rhud.matrix[arc][rhudDataTable[arc].growth], color = {
			{r=rhudDataTable[arc].color.fs[1], g=rhudDataTable[arc].color.fs[2], b=rhudDataTable[arc].color.fs[3], a=rhudDataTable[arc].color.fs[4],	position = 0},
			{r=rhudDataTable[arc].color.fe[1], g=rhudDataTable[arc].color.fe[2], b=rhudDataTable[arc].color.fe[3], a=rhudDataTable[arc].color.fe[4],	position = 1},
		}}
		rhud.OptionsSetBTabDArc:SetShape(rhud.configpath, rhud.configfill, rhud.stroke)
		rhud.WindowOptionsColorChooser:SetVisible(false)
		rhud.createWindow()
		rhud.LoadPlayer()
	end
	
	rhud.WindowOptionsTab:SetPoint("TOPLEFT", rhud.WindowOptions, "TOPLEFT", 15, 50)
	rhud.WindowOptionsTab:SetPoint("BOTTOMRIGHT", rhud.WindowOptions, "BOTTOMRIGHT", -15, -15)
	function rhud.WindowOptionsTab.Event.TabSelect()
			rhud.colorselect = 0
			rhud.WindowOptionsColorChooser:SetVisible(false)
		if rhud.WindowOptionsTab:GetActiveTab() == 4 then
			rhud.OptionsRadioATabD[1]:SetSelected(true, true)
			rhud.OptionsFrameATabD:SetVisible(true) rhud.OptionsFrameBTabD:SetVisible(false) rhud.OptionsFrameCTabD:SetVisible(false)
			for i = 1, 9 do rhud.OptionsRadioBTabD[i]:SetSelected(false) end
			for i = 1, 7 do rhud.OptionsRadioCTabD[i]:SetSelected(false) end
			for i = 1, 6 do rhud.OptionsRadioDTabD[i]:SetSelected(false) end
			for i = 1, 4 do rhud.OptionsRadioAATabD[i]:SetEnabled(false) rhud.OptionsRadioAATabD[i]:SetSelected(false) end
			rhud.OptionsSetBTabDArc:SetVisible(false)
			rhud.OptionsSetCTabDArc:SetVisible(false)
			rhud.OptionsSetDTabDArc:SetVisible(false)
			rhudcolorsel, rhud.colorarc = nil, nil
		end

		for i = 1, 12 do
			rhud.arcback[i]:SetBackgroundColor(1, 1, 1, 0)
			rhud.arcback[i]:SetVisible(false)
			rhud.arctextback[i]:SetBackgroundColor(1, 1, 1, 0)
			rhud.arctextback[i]:SetVisible(false)
		end
		for i = 1, 19 do
			rhud.OptionsUIElements[i]:SetBackgroundColor(1, 1, 1, 0)
			rhud.OptionsUIElements[i]:SetVisible(false)
		end
		for i = 1, 4 do
			rhud.OptionsRadioBTabB[i]:SetEnabled(false)
		end
		if rhudSData.size[rhudSData.skinval][3] == 2 then
			rhud.OptionsRadioATabB[1]:SetEnabled(false)
			rhud.OptionsRadioATabB[3]:SetEnabled(false)
			rhud.OptionsRadioATabB[4]:SetEnabled(false)
			rhud.OptionsRadioATabB[7]:SetEnabled(false)
			rhud.OptionsRadioATabB[9]:SetEnabled(false)
			rhud.OptionsRadioATabB[11]:SetEnabled(false)
			rhud.OptionsRadioATabB[12]:SetEnabled(false)
		else
			rhud.OptionsRadioATabB[1]:SetEnabled(true)
			rhud.OptionsRadioATabB[3]:SetEnabled(true)
			rhud.OptionsRadioATabB[4]:SetEnabled(true)
			rhud.OptionsRadioATabB[7]:SetEnabled(true)
			rhud.OptionsRadioATabB[9]:SetEnabled(true)
			rhud.OptionsRadioATabB[11]:SetEnabled(true)
			rhud.OptionsRadioATabB[12]:SetEnabled(true)
		end
	end
	
-------------------------------
	rhud.WindowOptions:SetCloseButtonVisible(true)
	function rhud.WindowOptions.Event.Close()
		rhud.Window:SetAlpha(rhudSData.aoc)
			for i = 1, 12 do
				rhud.arcback[i]:SetVisible(false)
				rhud.arcback[i]:SetBackgroundColor(1, 1, 1, 0)
				rhud.arctextback[i]:SetVisible(false)
				rhud.arctextback[i]:SetBackgroundColor(1, 1, 1, 0)
			end
			for i = 1, 19 do
				rhud.OptionsUIElements[i]:SetBackgroundColor(1, 1, 1, 0)
				rhud.OptionsUIElements[i]:SetVisible(false)
			end
			rhud.OptionsUIElementsText[1]:SetVisible(true)
			rhud.WindowOptions:SetVisible(false)
			rhud.createWindow()
			rhud.LoadPlayer()
	end
end
function rhud.toggleConfig()
	if rhudSData.isincombat == false then
		if rhud.WindowOptions:GetVisible() == false then
			rhud.WindowOptions:SetVisible(true)
		else
			for i = 1, 12 do
				rhud.arcback[i]:SetBackgroundColor(1, 1, 1, 0)
				rhud.arctextback[i]:SetBackgroundColor(1, 1, 1, 0)
				rhud.arcback[i]:SetVisible(false)
				rhud.arctextback[i]:SetVisible(false)
			end
			for i = 1, 19 do
				rhud.OptionsUIElements[i]:SetBackgroundColor(1, 1, 1, 0)
				rhud.OptionsUIElements[i]:SetVisible(false)
			end
			if rhudIconsDB[1].showicon == true then
				rhud.OptionsUIElementsText[1]:SetVisible(true)
			end
			rhud.WindowOptions:SetVisible(false)
			rhud.LoadPlayer()
		end
	end
end
